package org.rndclub.member;

import java.io.*;
import java.sql.*;
import java.util.*;
import org.rndclub.dbpool.ConnectionPool;

public class MemberProcessBean {
   int rowPerPage=10;
   int numberOfRow=0;
   int numberOfPage=0;

   public int getNumberOfRow() {
      return(numberOfRow);
   }

   public int getNumberOfPage() {
      return(numberOfPage);
   }

   public int getRowPerPage() {
      return(rowPerPage);
   }

   public void setRowPerPage(int rowPerPage) {
      this.rowPerPage = rowPerPage;
   }

   public boolean availablePage(int pageNum) {
      numberOfPage = ((numberOfRow-1) / rowPerPage) + 1;

      if((pageNum >= 1)&&(pageNum <= numberOfPage)) {
         return(true);
      } else {
         return(false);
      }
   }

   public boolean availablePrevPage(int pageNum) {
      if(pageNum > 1) {
         return(true);
      } else {
         return(false);
      }
   }

   public boolean availableNextPage(int pageNum) {
      numberOfPage = ((numberOfRow-1) / rowPerPage) + 1;

      if(pageNum < numberOfPage) {
         return(true);
      } else {
         return(false);
      }
   }

   public void register(MemberBean member)
   throws SQLException {
      String query = "INSERT INTO member ("
                   + "id, password, hintQ, hintA, email, name, "
                   + "residentNum1, residentNum2, zipNum1, zipNum2, address, "
                   + "phoneNum1, phoneNum2, phoneNum3, job, imageType, image, writeDate, refCount) "
                   + "VALUES("
                   + "?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?,0)";
      PreparedStatement pstmt = ConnectionPool.prepareStatement(query);

      pstmt.setString( 1, member.getId());
      pstmt.setString( 2, member.getPassword());
      pstmt.setString( 3, member.getHintQ());
      pstmt.setString( 4, member.getHintA());
      pstmt.setString( 5, member.getEmail());
      pstmt.setString( 6, member.getName());
      pstmt.setString( 7, member.getResidentNum1());
      pstmt.setString( 8, member.getResidentNum2());
      pstmt.setString( 9, member.getZipNum1());
      pstmt.setString(10, member.getZipNum2());
      pstmt.setString(11, member.getAddress());
      pstmt.setString(12, member.getPhoneNum1());
      pstmt.setString(13, member.getPhoneNum2());
      pstmt.setString(14, member.getPhoneNum3());
      pstmt.setString(15, member.getJob());
      pstmt.setString(16, member.getImageType());
      pstmt.setBinaryStream(17, member.getImage(), member.getImageSize());
      pstmt.setTimestamp(18, new Timestamp(Calendar.getInstance().getTime().getTime()));

      if(pstmt.executeUpdate() < 1) {
         throw new SQLException("[Member] Insert failed");
      }

      pstmt.close();
   }

   public void modify(MemberBean member)
   throws SQLException {
      Statement stmt = ConnectionPool.createStatement();
      String setStr = (member.getId() == null ? "" : ("id='"+member.getId()+"', "))
                    + (member.getPassword() == null ? "" : ("password='"+member.getPassword()+"', "))
                    + (member.getHintQ() == null ? "" : ("hintQ='"+member.getHintQ()+"', "))
                    + (member.getHintA() == null ? "" : ("hintA='"+member.getHintA()+"', "))
                    + (member.getEmail() == null ? "" : ("email='"+member.getEmail()+"', "))
                    + (member.getResidentNum1() == null ? "" : ("residentNum1='"+member.getResidentNum1()+"', "))
                    + (member.getResidentNum2() == null ? "" : ("residentNum2='"+member.getResidentNum2()+"', "))
                    + (member.getZipNum1() == null ? "" : ("zipNum1='"+member.getZipNum1()+"', "))
                    + (member.getZipNum2() == null ? "" : ("zipNum2='"+member.getZipNum2()+"', "))
                    + (member.getAddress() == null ? "" : ("address='"+member.getAddress()+"', "))
                    + (member.getPhoneNum1() == null ? "" : ("phoneNum1='"+member.getPhoneNum1()+"', "))
                    + (member.getPhoneNum2() == null ? "" : ("phoneNum2='"+member.getPhoneNum2()+"', "))
                    + (member.getPhoneNum3() == null ? "" : ("phoneNum3='"+member.getPhoneNum3()+"', "))
                    + (member.getJob() == null ? "" : ("job='"+member.getJob()+"', "));

      String query=null;
      if(setStr.endsWith(", ")) {
         setStr = setStr.substring(0, setStr.length()-2);
         query = "UPDATE member SET " + setStr + " WHERE seqNum="+member.getSeqNum();

         if(stmt.executeUpdate(query) < 1) {
            throw new SQLException("[Member] Information Update failed");
         }

         query = "UPDATE member SET imageType=?, image=? WHERE seqNum=?";
         PreparedStatement pstmt = ConnectionPool.prepareStatement(query);

         if(member.getImage() != null) {
            pstmt.setString(1, member.getImageType());
            pstmt.setBinaryStream(2, member.getImage(), member.getImageSize());
            pstmt.setInt(3, (int)member.getSeqNum());

            if(pstmt.executeUpdate() < 1) {
               throw new SQLException("[Member] Image Update failed");
            }
         }
         pstmt.close();
      }
      stmt.close();
   }

   public void delete(long seqNum)
   throws SQLException {
      Statement stmt = ConnectionPool.createStatement();
      String query = "DELETE FROM member WHERE seqNum="+seqNum;

      if(stmt.executeUpdate(query) < 1) {
         throw new SQLException("[Member] Delete failed");
      }
      stmt.close();
   }

   public ArrayList selectPage(int pageNum)
   throws SQLException {
      Statement stmt = ConnectionPool.createStatement();
      String query = "SELECT count(id) as numberOfRow FROM member";
      ResultSet rs = stmt.executeQuery(query);

      if(rs.next()) {
         numberOfRow = rs.getInt("numberOfRow");
      } else {
         numberOfRow = 0;
      }
      numberOfPage = ((numberOfRow-1) / rowPerPage) + 1;

      if(!availablePage(pageNum)) {
         pageNum = 1;
      }
      rs.close();

      query = "SELECT seqNum, id, email, name, residentNum1, residentNum2, phoneNum1, phoneNum2, phoneNum3, job, writeDate "
            + "FROM member "
            + "ORDER BY seqNum DESC";
      rs = stmt.executeQuery(query);
      for(int i=0;i<((pageNum-1) * rowPerPage);i++) {
         if(!rs.next()) {
            throw new SQLException("[Member] ResultSet is out of index");
         }
      }

      ArrayList memberArray = new ArrayList();
      for(int i=0;i<rowPerPage;i++) {
         if(!rs.next()) {
            break;
         }
         MemberBean member = new MemberBean();

         member.setSeqNum(rs.getLong("seqNum"));
         member.setId(rs.getString("id"));
         member.setEmail(rs.getString("email"));
         member.setName(rs.getString("name"));
         member.setResidentNum1(rs.getString("residentNum1"));
         member.setResidentNum2(rs.getString("residentNum2"));
         member.setPhoneNum1(rs.getString("phoneNum1"));
         member.setPhoneNum2(rs.getString("phoneNum2"));
         member.setPhoneNum3(rs.getString("phoneNum3"));
         member.setJob(rs.getString("job"));
         member.setWriteDate(rs.getTimestamp("writeDate"));

         memberArray.add(member);
      }
      rs.close();
      stmt.close();

      return(memberArray);
   }

   public MemberBean selectInformation(long seqNum)
   throws SQLException {
      Statement stmt = ConnectionPool.createStatement();
      String query = "UPDATE member SET refCount=refCount+1 WHERE seqNum="+seqNum;
      if(stmt.executeUpdate(query) < 1) {
         throw new SQLException("[Member] Update failed");
      }

      query = "SELECT seqNum, id, password, hintQ, hintA, email, name, residentNum1, residentNum2, zipNum1, zipNum2, address, phoneNum1, phoneNum2, phoneNum3, job, writeDate, refCount "
            + "FROM member "
            + "WHERE seqNum="+seqNum;
      ResultSet rs = stmt.executeQuery(query);

      MemberBean member = new MemberBean();
      if(rs.next()) {
         member.setSeqNum(rs.getLong("seqNum"));
         member.setId(rs.getString("id"));
         member.setPassword(rs.getString("password"));
         member.setHintQ(rs.getString("hintQ"));
         member.setHintA(rs.getString("hintA"));
         member.setEmail(rs.getString("email"));
         member.setName(rs.getString("name"));
         member.setResidentNum1(rs.getString("residentNum1"));
         member.setResidentNum2(rs.getString("residentNum2"));
         member.setZipNum1(rs.getString("zipNum1"));
         member.setZipNum2(rs.getString("zipNum2"));
         member.setAddress(rs.getString("address"));
         member.setPhoneNum1(rs.getString("phoneNum1"));
         member.setPhoneNum2(rs.getString("phoneNum2"));
         member.setPhoneNum3(rs.getString("phoneNum3"));
         member.setJob(rs.getString("job"));
         member.setWriteDate(rs.getTimestamp("writeDate"));
         member.setRefCount(rs.getInt("refCount"));
      }
      rs.close();
      stmt.close();

      return(member);
   }

   public MemberBean selectImage(long seqNum)
   throws SQLException, IOException {
      Statement stmt = ConnectionPool.createStatement();
      String query = "SELECT seqNum, imageType, image "
                   + "FROM member "
                   + "WHERE seqNum="+seqNum;
      ResultSet rs = stmt.executeQuery(query);

      MemberBean member = new MemberBean();
      if(rs.next()) {
         member.setSeqNum(rs.getLong("seqNum"));
         member.setImageType(rs.getString("imageType"));
         member.setImage(rs.getBinaryStream("image"));
      }
      rs.close();
      stmt.close();

      return(member);
   }

   public boolean validate(MemberBean member)
   throws SQLException, IOException {
      boolean flag = false;

      Statement stmt = ConnectionPool.createStatement();
      String query = "SELECT seqNum, id, password "
                   + "FROM member "
                   + "WHERE id='"+member.getId()+"' AND"
                   + "      password='"+member.getPassword()+"'";
      ResultSet rs = stmt.executeQuery(query);
      if(rs.next()) {
         member.setSeqNum(rs.getInt("seqNum"));
         flag = true;
      }
      rs.close();
      stmt.close();

      return(flag);
   }
}
