package org.rndclub.qna;

import java.sql.*;
import java.util.*;
import org.rndclub.dbpool.ConnectionPool;

public class QnaProcessBean {
   int rowPerPage=10;
   int numberOfRow=0;
   int numberOfPage=0;

   public int getNumberOfRow() {
      return(numberOfRow);
   }

   public int getNumberOfPage() {
      return(numberOfPage);
   }

   public int getRowPerPage() {
      return(rowPerPage);
   }

   public void setRowPerPage(int rowPerPage) {
      this.rowPerPage = rowPerPage;
   }

   public boolean availablePage(int pageNum) {
      numberOfPage = ((numberOfRow-1) / rowPerPage) + 1;

      if((pageNum >= 1)&&(pageNum <= numberOfPage)) {
         return(true);
      } else {
         return(false);
      }
   }

   public boolean availablePrevPage(int pageNum) {
      if(pageNum > 1) {
         return(true);
      } else {
         return(false);
      }
   }

   public boolean availableNextPage(int pageNum) {
      numberOfPage = ((numberOfRow-1) / rowPerPage) + 1;

      if(pageNum < numberOfPage) {
         return(true);
      } else {
         return(false);
      }
   }

   public int getLastId() throws SQLException {
      int maxId=0;

      Statement stmt = ConnectionPool.createStatement();
      ResultSet rs = stmt.executeQuery("SELECT MAX(q_id) as maxId FROM qna");
      if((rs == null)||(!rs.next())) {
         stmt.close();
         throw new SQLException("Error: Result is null or has no data");
      }
      maxId = rs.getInt("maxId") + 1;
      rs.close();
      stmt.close();

      return maxId;
   }

   public int getLastRef() throws SQLException {
      int maxNumber=0;

      Statement stmt = ConnectionPool.createStatement();
      ResultSet rs = stmt.executeQuery("SELECT MAX(q_ref) as maxRef FROM qna");
      if((rs == null)||(!rs.next())) {
         stmt.close();
         throw new SQLException("Error: Result is null or has no data");
      }
      maxNumber = rs.getInt("maxRef") + 1;
      rs.close();
      stmt.close();

      return maxNumber;
   }

   public ArrayList selectPage(int pageNum, SearchBean searchBean) throws SQLException {
      String counterSql="";
      String selectSql="";

      if("0".equals(searchBean.getItem())) {
         counterSql = "SELECT count(*) as counter from qna";//ü rows ΰ.. Ʈ ΰ..
         selectSql = "SELECT q_id, q_subject, q_name, q_email, q_visited, q_comments, q_write_date, q_ref, q_step, q_ansnum FROM qna ORDER BY q_ref desc, q_ansnum asc";
      } else if("1".equals(searchBean.getItem())) {
         counterSql = "SELECT count(*) as counter from qna WHERE q_name LIKE '%"+searchBean.getValue()+"%'";
         selectSql = "SELECT q_id, q_subject, q_name, q_email, q_visited, q_comments, q_write_date, q_ref, q_step, q_ansnum FROM qna WHERE q_name LIKE '%"+searchBean.getValue()+"%' order by q_ref desc, q_ansnum asc";
      } else if("2".equals(searchBean.getItem())) {
         counterSql = "SELECT count(*) as counter from qna WHERE q_subject LIKE '%"+searchBean.getValue()+"%'";
         selectSql = "SELECT q_id, q_subject, q_name, q_email, q_visited, q_comments, q_write_date, q_ref, q_step, q_ansnum FROM qna WHERE q_subject LIKE '%"+searchBean.getValue()+"%' order by q_ref desc, q_ansnum asc";
      } else if("3".equals(searchBean.getItem())) {
         counterSql = "SELECT count(*) as counter from qna WHERE q_comments LIKE '%"+searchBean.getValue()+"%'";
         selectSql = "SELECT q_id, q_subject, q_name, q_email, q_visited, q_comments, q_write_date, q_ref, q_step, q_ansnum FROM qna WHERE q_comments LIKE '%"+searchBean.getValue()+"%' order by q_ref desc, q_ansnum asc";
      }

      Statement stmt = ConnectionPool.createStatement();
      ResultSet rs = stmt.executeQuery(counterSql);
      if(rs.next()) {
         numberOfRow = rs.getInt("counter");
      } else {
         stmt.close();
         throw new SQLException("Resultset has no data.");
      }   
      rs.close();

      rs = stmt.executeQuery(selectSql);
      if(rs == null) {
         stmt.close();
         throw new SQLException("ResultSet is null");
      }
      for(int i=0;i<((pageNum-1) * rowPerPage);i++) {
         if(!rs.next()) {
            stmt.close();
            throw new SQLException("ResultSet is out of index");
         }
      }

      ArrayList qnaBeanArray = new ArrayList();
      for(int i=0;i<rowPerPage;i++) {
         if(!rs.next()) {
            break;
         }

         QnaBean qnaBean = new QnaBean();

         qnaBean.setId(rs.getInt("q_id"));
         qnaBean.setSubject(rs.getString("q_subject"));
         qnaBean.setName(rs.getString("q_name"));
         qnaBean.setEmail(rs.getString("q_email"));
         qnaBean.setVisited(rs.getInt("q_visited"));
         qnaBean.setComment(rs.getString("q_comments"));
         qnaBean.setDate(rs.getString("q_write_date"));

         qnaBean.setRef(rs.getInt("q_ref"));
         qnaBean.setStep(rs.getInt("q_step"));
         qnaBean.setAnsnum(rs.getInt("q_ansnum"));

         qnaBeanArray.add(qnaBean);
      }
      rs.close();
      stmt.close();

      return(qnaBeanArray);
   }

   public QnaBean select(int id) throws SQLException {
      QnaBean qnaBean=null;

      String query = "SELECT * FROM qna WHERE q_id ="+id;

      Statement stmt = ConnectionPool.createStatement();
      ResultSet rs = stmt.executeQuery(query);
      if((rs != null)&&(rs.next())) {
         qnaBean = new QnaBean();

         qnaBean.setId(rs.getInt("q_id"));
         qnaBean.setPassword(rs.getString("q_passwd"));
         qnaBean.setSubject(rs.getString("q_subject"));
         qnaBean.setName(rs.getString("q_name"));
         qnaBean.setEmail(rs.getString("q_email"));
         qnaBean.setVisited(rs.getInt("q_visited")+1);
         qnaBean.setComment(rs.getString("q_comments"));
         qnaBean.setDate(rs.getString("q_write_date"));

         qnaBean.setRef(rs.getInt("q_ref"));
         qnaBean.setStep(rs.getInt("q_step"));
         qnaBean.setAnsnum(rs.getInt("q_ansnum"));

         rs.close();

         query = "UPDATE qna SET q_visited = "+qnaBean.getVisited()+" WHERE q_id = "+id;
         stmt.executeUpdate(query);
      }
      stmt.close();

      return(qnaBean);
   }

   public void insert(QnaBean qnaBean) throws SQLException {
      String query = "INSERT INTO qna (q_id, q_subject, q_name, q_email, q_visited, q_comments, q_write_date, q_ref, q_step, q_ansnum, q_passwd)"
                   + "VALUES ("+qnaBean.getId() + ",'"
                   + qnaBean.getSubject() + "','"
                   + qnaBean.getName() + "','"
                   + qnaBean.getEmail() + "', 0,'"
                   + qnaBean.getComment() + "','"
                   + qnaBean.getDate() + "',"
                   + qnaBean.getRef() + ","
                   + qnaBean.getStep() + ","
                   + qnaBean.getAnsnum() + ",'"
                   + qnaBean.getPassword() + "')";
      System.out.println(query);

      Statement stmt = ConnectionPool.createStatement();
      if(stmt.executeUpdate(query) < 1) {
         stmt.close();
         throw new SQLException("Insert failed. QUERY["+query+"]");
      }
      stmt.close();
   }

   public void update(QnaBean qnaBean) throws SQLException {
      qnaBean.setDate();

      String query = "UPDATE qna SET "
                   + "q_name='" + qnaBean.getName()
                   + "', q_email='" + qnaBean.getEmail()
                   + "', q_write_date='" + qnaBean.getDate()
                   + "', q_subject='" + qnaBean.getSubject()
                   + "', q_comments='" + qnaBean.getComment();
      if((qnaBean.getPassword() != null)&&(!"".equals(qnaBean.getPassword()))) {
         query += "', q_passwd='" + qnaBean.getPassword();
      }
      query += "' WHERE q_id =" + qnaBean.getId();
      System.out.println(query);

      Statement stmt = ConnectionPool.createStatement();
      if(stmt.executeUpdate(query) < 1) {
         stmt.close();
         throw new SQLException("Update failed. QUERY["+query+"]");
      }
      stmt.close();
   }

   public void answer(QnaBean qnaBean) throws SQLException {
      String query = "UPDATE qna SET q_ansnum=q_ansnum+1 "
                   + "WHERE q_ref=" + qnaBean.getRef()
                   + " AND q_ansnum>"+qnaBean.getAnsnum();

      Statement stmt = ConnectionPool.createStatement();
      stmt.executeUpdate(query);

      qnaBean.setAnsnum(qnaBean.getAnsnum()+1);
      qnaBean.setStep(qnaBean.getStep()+1);

      insert(qnaBean);

      stmt.close();
   }

   public void delete(int id, String password) throws SQLException {
      String query = "SELECT q_ref, q_ansnum FROM qna WHERE q_id="+ id
                   +" AND q_passwd='" + password + "'";

      Statement stmt = ConnectionPool.createStatement();
      ResultSet rs = stmt.executeQuery(query);
      if((rs != null)&&(rs.next())) {
         int ref = rs.getInt("q_ref");
         int ansnum = rs.getInt("q_ansnum");

         rs.close();

         query = "UPDATE qna SET q_ansnum=q_ansnum-1 "
               + "WHERE q_ref="+ref+" AND q_ansnum>"+ansnum;
         stmt.executeUpdate(query);
         query = "DELETE FROM qna WHERE q_id="+id;
         if(stmt.executeUpdate(query) < 1) {
            stmt.close();
            throw new SQLException("Delete failed. QUERY["+query+"]");
         }
      } else {
         stmt.close();
         throw new SQLException("Delete failed. QUERY["+query+"]");
      }
      stmt.close();
   }

   public boolean validate(int id, String password) throws SQLException {
      String query = "SELECT q_id FROM qna WHERE q_id="+ id
                   +" AND q_passwd='"+password+"'";

      Statement stmt = ConnectionPool.createStatement();
      ResultSet rs = stmt.executeQuery(query);
      if(rs.next()) {
         return(true);
      }   
      stmt.close();

      return(false);
   }
}
