package rndclub.game.hiddencatch;
import java.awt.*;

// ̹ ְ  ó   ֵ  
class ImageCanvas extends Canvas {
   final static int STATE_FRONT=0;  // ̹   - ո
   final static int STATE_BACK=1;   // ̹   - ޸
   final static int INVALID_ID=-1;  // ̹ ̵
   final static int MISMATCH_NUM=5; // Ʋ κ ִ  - 5

   Rectangle mismatchArea[]=null;   // Ʋ κп شϴ  Ÿ
   boolean searchArea[]=null;       // Ʋ κ  
   int state=STATE_BACK;            // ̹ 
   Image image=null;                // ̹

   // ü 
   public ImageCanvas() {
      this.image = null;
      init();
   }

   // ü 
   public ImageCanvas(int id, Image image) {
      this.image = image;
      init();
   }

   // ̹ Ʈ ʱȭ
   public void init() {
      if(image == null) {
         setSize(0, 0); // ̹    ũ⸦ 0 
      }
      if(mismatchArea == null) {
         mismatchArea = new Rectangle[MISMATCH_NUM];  // 迭 
         searchArea = new boolean[MISMATCH_NUM];      // 迭 
      }
      for(int i=0;i<mismatchArea.length;i++) {
         mismatchArea[i] = new Rectangle();  // 迭 Rectangle ü 
         searchArea[i] = false;              // 迭  ʱȭ
      }
      //  ʱȭ
      setBackground(new Color(0x22, 0x22, 0x66));
      state = STATE_BACK;
   }

   // Ǿ ִ ° Ѵ.
   public int getState() {
      return(state);
   }

   // ° Ѵ.
   public void setState(int state) {
      this.state = state;
   }

   // 콺 Ŭ ǥ Ʋ κп شϴ θ üũ
   public int correctArea(int x, int y) {
      //  ̹ ũ ȭ ũ⸦ ݿϱ 
      // ֳϸ game.property   ̹  ̰,
      // ȭ󿡼  ũⰡ ٲ ǹǷ  ʿ
      double ww = ((double)image.getWidth(this) / (double)(getSize().width));
      double hh = ((double)image.getHeight(this) / (double)(getSize().height));

      // ȭ󿡼 콺 ǥ ̹ ǥ ȯ
      x = (int)((double)x * ww);
      y = (int)((double)y * hh);

      // Ʋ κп شϴ üũ
      Rectangle r=null;
      for(int i=0;i<mismatchArea.length;i++) {
         r = new Rectangle(mismatchArea[i].x,
                           mismatchArea[i].y,
                           mismatchArea[i].width - mismatchArea[i].x + 1,
                           mismatchArea[i].height - mismatchArea[i].y + 1);
         if(r.contains(x, y)) {
            return(i);
         }
      }
      return(-1);
   }

   // ־ Ʋ κ ڰ ̹  κ ƴ üũ
   public boolean isVirgin(int i) {
      return(searchArea[i] == false);
   }

   // ־ Ʋ κ ڰ  κ  üũ
   public void disableVirgin(int i) {
      searchArea[i] = true;
   }

   //  ̹ ǥ ȭ ǥ 
   public Rectangle resizing(int x, int y, int width, int height) {
      double ww = ((double)(getSize().width) / (double)image.getWidth(this));
      double hh = ((double)(getSize().height) / (double)image.getHeight(this));

      return(new Rectangle((int)(x*ww), (int)(y*hh), (int)(width*ww), (int)(height*hh)));
   }

   // ̹ Ǿ ִ ̹ Ѵ.
   public Image getImage() {
      return(image);
   }

   // Ÿ ̹ Ѵ.
   public void setImage(Image image) {
      this.image = image;
      init();
   }

   // ̹ ¸ ޸ Ѵ.
   public void setBack() {
      state = STATE_BACK;
      repaint();
   }

   // ̹ ¸ ո Ѵ.
   public void setFront() {
      state = STATE_FRONT;
      repaint();
   }

   // Ÿ ̹ Ʋ κ Ѵ.
   public void setBounds(Rectangle r[]) {
      if(r == null) {
         return;
      }
      for(int i=0;i<5;i++) {
         if(r[i] == null) {
            mismatchArea[i].setBounds(0, 0, 0, 0);
         } else {
            mismatchArea[i].setBounds(r[i]);
         }
      }
   }

   //  ڰ  κ  ڽ ׸.
   public void drawCorrect(int i) {
      if((i < 0)||(i >= mismatchArea.length)) {
         return;
      }
      // ̹ ǥ ȭ ǥ ȯ 
      double ww = (double)((double)image.getWidth(this) / (double)getSize().width);
      double hh = (double)((double)image.getHeight(this) / (double)getSize().height);

      Graphics g = getGraphics();

      int x = (int)(mismatchArea[i].x / ww);
      int y = (int)(mismatchArea[i].y / hh);
      int w = (int)(mismatchArea[i].width / ww) - x + 1;
      int h = (int)(mismatchArea[i].height / hh) - y + 1;

      g.setColor(Color.red);  //  ڽ ׸ 
      g.drawRect(x, y, w, h);
      g.drawRect(x+1, y+1, w-2, h-2);
      g.drawRect(x+2, y+2, w-4, h-4);
   }

   // (x,y) ǥ شϴ Ʋ κ ׷ش.
   public void drawCorrect(int x, int y) {
      drawCorrect(correctArea(x, y));
   }

   // ڰ Ʋ κ ƴ ٸ κп Ʋ ,
   // ش ġ(x,y) X ǥ ׸.
   public void drawIncorrect(int x, int y) {
      Graphics g = getGraphics();

      g.setColor(Color.red);
      g.drawLine(x-7, y-8, x+8, y+7);
      g.drawLine(x-8, y-8, x+8, y+8);
      g.drawLine(x-8, y-7, x+7, y+8);

      g.drawLine(x-8, y+7, x+7, y-8);
      g.drawLine(x-8, y+8, x+8, y-8);
      g.drawLine(x-7, y+8, x+8, y-7);

      try {
         Thread.sleep(500);   // X ǥ   ֵ ̸ 
      } catch (InterruptedException e) { }

      repaint();  // ٽ  ȭ 
   }

   //    , Ʋ κ(5)  ش.
   public void drawAll() {
      for(int i=0;i<mismatchArea.length;i++) {
         drawCorrect(i);
      }
      try {
         Thread.sleep(750);   // ڰ   ֵ ̸ 
      } catch (InterruptedException e) { }
   }

   // paint() ޼ҵ尡 ̺Ʈ  ȣ ʰ, ٷ ȣǵ ϱ 
   public void repaint() {
      update(getGraphics());
   }

   // update() ޼ҵ带 Ͽ ̴  
   public void update(Graphics g) {
      paint(g);
   }

   //  ̹   ڰ  Ʋ κ ׷
   public void paint(Graphics g) {
      if(g == null) return;
      int width = getSize().width;
      int height = getSize().height;

      if((image != null)&&(state == STATE_FRONT)) {
         // ̹ Ǿ ְ,  κ 
         // ̹ ȭ鿡 ° ׸ Ǵµ,
         //  κ   ̹  ϴ ǥü
         // ̹ Ʈ  ǥü谡 ޶.
         g.drawImage(image, 0, 0, width, height, this);

         g.setColor(Color.black);
         g.drawRect(0, 0, width-1, height-1);

         // ̹  ڰ Ʋ κ ٴ  ֱ ,
         // ش Ʋ κ  ڽ ׷ش.
         for(int i=0;i<mismatchArea.length;i++) {
            if(searchArea[i] == true) {
               drawCorrect(i);
            }
         }
      } else {
         // ̹ Ǿ  ʰų Ǵ  κ 쿡
         //   ڽ ׷ ش.
         g.setColor(getBackground());
         g.fillRect(0, 0, width-1, height-1);   // ڽ ׸

         g.setColor(Color.black);
         g.drawRect(0, 0, width-1, height-1);   // ׵θ ׸
      }
   }
}
