/*
 * Project: MW Dilemma Game
 *    File: ClientRoom.java
 *    Date: 2 10, 2001
 * Authhor: Yongwoo's Park.
 */

package rndclub.game.mw;
import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;
import java.sql.*;
import java.util.Vector;
import java.util.Hashtable;
import java.util.Enumeration;
import java.util.StringTokenizer;

public class ClientRoom extends Panel {
   ClientLobby parentApplet=null;

   Image backgroundImage=null;
   ImageCanvas backgroundCanvas=null;

   ImageButton mButton=null;
   ImageButton wButton=null;
   ImageButton exitButton=null;

   ImageCanvas leftMW=null;
   ImageCanvas rightMW=null;

   Image mImage=null;
   Image wImage=null;

   Image mButtonImage[]=null;
   Image wButtonImage[]=null;
   Image exitButtonImage[]=null;

   Label playerId1Label=null;
   Label playerId2Label=null;
   Label pointLabel=null;

   List playerList=null;
   TextArea chatArea=null;
   TextField chatField=null;
   Choice chatChoice=null;

   Image offImage=null;
   Graphics offGraphics=null;

   int myX=-1, yourX=-1;

   public ClientRoom(ClientLobby parentApplet) {
      this.parentApplet = parentApplet;
      init();
      initGame();
   }

   public void init(ClientLobby parentApplet) {
      this.parentApplet = parentApplet;
      init();
      initGame();
   }

   public void init() {
      setLayout(null);

      MediaTracker mwTrack = new MediaTracker(this);

      mButtonImage = new Image[3];
      wButtonImage = new Image[3];
      exitButtonImage = new Image[3];

      chatField = new TextField();
      chatArea = new TextArea();
      chatChoice = new Choice();
      chatChoice.add("BROADCAST");
      chatChoice.add("GROUPCAST");
      playerList = new List();

      playerId1Label = new Label();
      playerId2Label = new Label();
      pointLabel = new Label();

      backgroundImage = parentApplet.getImage(parentApplet.getDocumentBase(), "images/game-in2.gif");
      mwTrack.addImage(backgroundImage, 0);
      for(int i=0;i<3;i++) {
         mButtonImage[i] = parentApplet.getImage(parentApplet.getDocumentBase(),
                                                 "images/mb1-"+(i+1)+".gif");
         mwTrack.addImage(mButtonImage[i], 0);
      }
      for(int i=0;i<3;i++) {
         wButtonImage[i] = parentApplet.getImage(parentApplet.getDocumentBase(),
                                                 "images/wb1-"+(i+1)+".gif");
         mwTrack.addImage(wButtonImage[i], 0);
      }
      for(int i=0;i<3;i++) {
         exitButtonImage[i] = parentApplet.getImage(parentApplet.getDocumentBase(),
                                                    "images/in-quit"+(i+1)+".gif");
         mwTrack.addImage(exitButtonImage[i], 0);
      }
      mImage = parentApplet.getImage(parentApplet.getDocumentBase(), "images/m1.gif");
      wImage = parentApplet.getImage(parentApplet.getDocumentBase(), "images/w1.gif");
      mwTrack.addImage(mImage, 0);
      mwTrack.addImage(wImage, 0);
      try {
         mwTrack.waitForAll();
      } catch(InterruptedException e) {
      }

      backgroundCanvas = new ImageCanvas(backgroundImage, this, 800, 555);

      mButton = new ImageButton(mButtonImage[0], mButtonImage[1], mButtonImage[2]);
      wButton = new ImageButton(wButtonImage[0], wButtonImage[1], wButtonImage[2]);
      exitButton = new ImageButton(exitButtonImage[0], exitButtonImage[1], exitButtonImage[2]);

      leftMW = new ImageCanvas(mImage, this, mImage.getWidth(this), mImage.getHeight(this));
      rightMW = new ImageCanvas(wImage, this, wImage.getWidth(this), wImage.getHeight(this));

      backgroundCanvas.setBounds(0, 0, 800, 555);

//      mButton.setBounds(255, 413, 103, 108);
//      wButton.setBounds(461, 413, 103, 108);
      mButton.setBounds(304, 293, 72, 72);
      wButton.setBounds(450, 293, 72, 72);
      exitButton.setBounds(723, 494, 26, 26);

//      leftMW.setBounds(163, 188, 124, 121);
//      rightMW.setBounds(529, 188, 124, 121);
      leftMW.setBounds(188, 154, 116, 102);
      rightMW.setBounds(514, 154, 116, 102);

//      playerId1Label.setBounds(168, 322, 120, 20);
      playerId1Label.setBounds(192, 264, 88, 16);
      playerId1Label.setAlignment(Label.CENTER);
      playerId1Label.setForeground(new Color(104, 97, 3));

//      playerId2Label.setBounds(528, 322, 120, 20);
      playerId2Label.setBounds(518, 264, 88, 16);
      playerId2Label.setAlignment(Label.CENTER);
      playerId2Label.setForeground(new Color(104, 97, 3));

//      pointLabel.setBounds(548, 322, 78, 20);

      // ä...

//      chatArea.setBounds(50, 350, 200, 150);
//      chatField.setBounds(50, 500, 200, 20);
      chatArea.setBounds(119, 388, 350, 97);
      chatField.setBounds(119, 490, 250, 23);
      chatChoice.setBounds(373, 490, 96, 23);

      chatArea.setForeground(new Color(104, 97, 3));
      chatArea.setBackground(new Color(229, 225, 24));
      chatField.setForeground(new Color(104, 97, 3));
      chatField.setBackground(new Color(225, 255, 152));
      chatChoice.setForeground(new Color(104, 97, 3));
      chatChoice.setBackground(new Color(225, 255, 152));

//      playerList.setBounds(570, 350, 200, 140);
      playerList.setBounds(480, 388, 210, 125);
      playerList.setForeground(new Color(104, 97, 3));
      playerList.setBackground(new Color(229, 225, 24));

//      mButton.setEnabled(false);
//      wButton.setEnabled(false);
      mButton.setEnabled(true);
      wButton.setEnabled(true);
      exitButton.setEnabled(true);

      add(mButton);
      add(wButton);
      add(exitButton);

      add(leftMW);
      add(rightMW);

      add(playerId1Label);
      add(playerId2Label);

      add(chatArea);
      add(chatField);
      add(chatChoice);
      add(playerList);

      add(backgroundCanvas);

      ActionListener al = new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            String message=null;
            if(e.getSource() == chatField) {
               String chatStr = chatField.getText().trim();
               chatField.setText("");

               if("".equals(chatStr)) {
                  return;
               }

               if("BROADCAST".equals(chatChoice.getSelectedItem())) {
                  message = "500|BROADCAST|"+parentApplet.playerId+"|*|"+chatStr;
               } else if("GROUPCAST".equals(chatChoice.getSelectedItem())) {
                  if(parentApplet.groupId == null) {
                     message = "500|BROADCAST|"+parentApplet.playerId+"|*|"+chatStr;
                  } else {
                     message = "502|GROUPCAST|"+parentApplet.playerId+"|"+parentApplet.groupId+"|"+chatStr;
                  }
               } else {
                  message = "500|BROADCAST|"+parentApplet.playerId+"|*|"+chatStr;
               }

               sendToServer(message);
            } else if(e.getSource() == mButton) {
               setButtonEvent(false);

               message = "522|PUT|"+parentApplet.groupId+"|M";
               sendToServer(message);
/*
               String chatStr = "["+parentApplet.groupId+"] [M] ½ϴ.";
               message = "502|GROUPCAST|"+parentApplet.playerId+"|"+parentApplet.groupId+"|"+chatStr;
               sendToServer(message);
*/
            } else if(e.getSource() == wButton) {
               setButtonEvent(false);

               message = "522|PUT|"+parentApplet.groupId+"|W";
               sendToServer(message);
/*
               String chatStr = "["+parentApplet.groupId+"] [W] ½ϴ.";
               message = "502|GROUPCAST|"+parentApplet.playerId+"|"+parentApplet.groupId+"|"+chatStr;
               sendToServer(message);
*/
            } else if(e.getSource() == exitButton) {
               sendToServer("582|EXIT_ROOM|"+parentApplet.playerId);
               parentApplet.godoriCardLayout.show(parentApplet.cardPanel, "LobbyPanel");
               parentApplet.buttonDefaultSetting();
            }
         }
      };

      chatField.addActionListener(al);

      mButton.addActionListener(al);
      wButton.addActionListener(al);
      exitButton.addActionListener(al);

      FocusListener fl = new FocusAdapter() {
         public void focusGained(FocusEvent e) {
            chatField.requestFocus();
         }
      };

      playerList.addFocusListener(fl);
      chatArea.addFocusListener(fl);

      chatField.requestFocus();

      offImage = parentApplet.createImage(parentApplet.getSize().width, parentApplet.getSize().height);
      offGraphics = offImage.getGraphics();
   }

   public void repaint() {
      paint(getGraphics());
   }

/*
   public void update(Graphics g) {
      paint(g);
   }

   public void paint(Graphics g) {
      offGraphics.drawImage(backgroundImage, 0, 0, getSize().width, getSize().height, this);

      offGraphics.drawImage(mImage, 163, 188, 124, 121, this);
      offGraphics.drawImage(wImage, 529, 188, 124, 121, this);

      switch(myX) {
         case 0: leftMW.setImage(mImage); break;
         case 1: leftMW.setImage(wImage); break;
         default:
            leftMW.setImage(null);
         break;
      }
      switch(yourX) {
         case 0: rightMW.setImage(mImage); break;
         case 1: rightMW.setImage(wImage); break;
         default:
            rightMW.setImage(null);
         break;
      }

      g.drawImage(offImage, 0, 0, this);
   }
*/

   public void messageBoard(String message) {
      chatArea.append("\n[޽] "+message+"\n\n");
   }

   public String receiveMessage() throws SocketException {
      try {
         return(parentApplet.receiveMessage());
      } catch(SocketException e) {
         throw(e);
      }
   }

   public void sendToServer(String message) {
      parentApplet.sendToServer(message);
   }

   public void setButtonEvent(boolean falg) {
      mButton.setEnabled(falg);
      wButton.setEnabled(falg);
      exitButton.setEnabled(true);
   }

   public void startGame() {
      setButtonEvent(true);
   }

   public void initGame() {
      setButtonEvent(false);
   }

   public void finishGame() {
      setButtonEvent(false);
   }

   public void myPut(String pae) {
      // X: 0-M, 1-W
      Image images[] = new Image[2];

      if("M".equals(pae)) {
         myX = 0;
      } else if("W".equals(pae)) {
         myX = 1;
      }
      images[0] = mImage;
      images[1] = wImage;

      for(int i=0;i<20;i++) {
         int rand = i;  // (int)(Math.random() * 2.0);

         leftMW.setImage(images[(rand+myX)%2]);
         try {
            Thread.sleep(50);
         } catch(InterruptedException e) {
         }
      }
      leftMW.setImage(images[myX]);
   }

   public void yourPut(String pae) {
      // X: 0-M, 1-W
      Image images[] = new Image[2];

      if("M".equals(pae)) {
         yourX = 0;
      } else if("W".equals(pae)) {
         yourX = 1;
      }
      images[0] = mImage;
      images[1] = wImage;

      for(int i=0;i<20;i++) {
         int rand = i;  // (int)(Math.random() * 2.0);

         rightMW.setImage(images[(rand+yourX)%2]);
         try {
            Thread.sleep(50);
         } catch(InterruptedException e) {
         }
      }
      rightMW.setImage(images[yourX]);
   }

   public void animatePut(String playerPae1, String playerPae2) {
      // X: 0-KaWui, 1-BaWui, 2-Bo
      Image images[] = new Image[2];

      if("M".equals(playerPae1)) {
         myX = 0;
      } else if("W".equals(playerPae1)) {
         myX = 1;
      }
      if("M".equals(playerPae2)) {
         yourX = 0;
      } else if("W".equals(playerPae2)) {
         yourX = 1;
      }
      images[0] = mImage;
      images[1] = wImage;

      for(int i=0;i<20;i++) {
         int rand = i;  // (int)(Math.random() * 2.0);

         leftMW.setImage(images[(rand+myX)%2]);
         rightMW.setImage(images[(rand+yourX)%2]);

         try {
            Thread.sleep(50);
         } catch(InterruptedException e) {
         }
      }
      leftMW.setImage(images[myX]);
      rightMW.setImage(images[yourX]);
   }

   public void putGame(String playerInfo1, String playerInfo2) {
      StringTokenizer st=null;

      st = new StringTokenizer(playerInfo1, ",");
      String groupId1 = st.nextToken();
      String groupMW1 = st.nextToken();

      st = new StringTokenizer(playerInfo2, ",");
      String groupId2 = st.nextToken();
      String groupMW2 = st.nextToken();

      if(parentApplet.groupId.equals(groupId1)) {
         animatePut(groupMW1, groupMW2);
      } else {
         animatePut(groupMW2, groupMW1);
      }
   }

   public void putPoint(String playerInfo1, String playerInfo2) {
      StringTokenizer st=null;

      st = new StringTokenizer(playerInfo1, ",");
      String groupId1 = st.nextToken();
      String groupPoint1 = st.nextToken();

      st = new StringTokenizer(playerInfo2, ",");
      String groupId2 = st.nextToken();
      String groupPoint2 = st.nextToken();

      if(parentApplet.groupId.equals(groupId1)) {
         playerId1Label.setText("["+groupId1+":"+groupPoint1+"]");
         playerId2Label.setText("["+groupId2+":"+groupPoint2+"]");
      } else {
         playerId1Label.setText("["+groupId2+":"+groupPoint2+"]");
         playerId2Label.setText("["+groupId1+":"+groupPoint1+"]");
      }
   }

   public void updateUserList(String playerIds) {
      if(playerIds != null) {
         StringTokenizer st = new StringTokenizer(playerIds, ",");
         playerList.removeAll();
         while(st.hasMoreTokens()) {
            playerList.add(st.nextToken());
         }
      }
   }

   public void processMessage(String receive) {
      StringTokenizer st = new StringTokenizer(receive, "|");
      String command = st.nextToken();
      if("700".equals(command)) {         // εĳ ä
         // εĳ ä  700|BROADCAST|playerId|*|chatStr
         String type = st.nextToken();
         String playerId = st.nextToken();
         String target = st.nextToken();
         String chatStr = st.nextToken();

         chatArea.append(chatStr+"\n");
      } else if("702".equals(command)) {         // εĳ ä
         // εĳ ä  702|GROUPCAST|playerId|groupId|chatStr
         String type = st.nextToken();
         String playerId = st.nextToken();
         String groupId = st.nextToken();
         String chatStr = st.nextToken();

         chatArea.append(chatStr+"\n");
      } else if("704".equals(command)) {         // εĳ ä
         // εĳ ä  704|UNICAST|playerId|toPlayerId|chatStr
         String type = st.nextToken();
         String fromPlayerId = st.nextToken();
         String toPlayerId = st.nextToken();
         String chatStr = st.nextToken();

         chatArea.append(chatStr+"\n");
      } else if("712".equals(command)) {
         // ڸƮ       712|playerId|roomId|playerId#1,playerId#2,,playerId#n
         String playerId = st.nextToken();
         String roomId = st.nextToken();
         String playerIds = st.nextToken();

         updateUserList(playerIds);
      } else if("720".equals(command)) {
         // ӽ       720|START|groupId
         String type = st.nextToken();
         String groupId = st.nextToken();

         startGame();
      } else if("721".equals(command)) {
         // ӽ       720|INIT|playerId
         String type = st.nextToken();
         String playerId = st.nextToken();

         initGame();
      } else if("722".equals(command)) {
         // Ӱ      722|PUT|groupId#1,[M|W]|groupId#2,[M|W]
         String type = st.nextToken();
         String playerInfo1 = st.nextToken();
         String playerInfo2 = st.nextToken();

         putGame(playerInfo1, playerInfo2);

         finishGame();
      } else if("723".equals(command)) {
         // Ӱ      723|PUT|groupId|[M|W]
         String type = st.nextToken();
         String groupId = st.nextToken();
         String mw = st.nextToken();

         if(parentApplet.groupId.equals(groupId)) {
            if("M".equals(mw)) {
               messageBoard("[M] ½ϴ.");
            } else if("W".equals(mw)) {
               messageBoard("[W] ½ϴ.");
            } else {
               messageBoard("[XXX] ½ϴ.");
            }
            myPut(mw);
         }
      } else if("724".equals(command)) {
         //         724|POINT|groupId#1,point#1|groupId#2,point#2
         String type = st.nextToken();
         String playerInfo1 = st.nextToken();
         String playerInfo2 = st.nextToken();

         putPoint(playerInfo1, playerInfo2);
      } else if("780".equals(command)) {
         //            780|JOIN_ROOM|playerId
         String type = st.nextToken();
         String playerId = st.nextToken();

         if(parentApplet.playerId.equals(playerId)) {
            playerId1Label.setText(playerId);
            finishGame();
         } else {
            playerId2Label.setText(playerId);
         }

         sendToServer("512|"+parentApplet.playerId+"|"+parentApplet.roomId);
      } else if("782".equals(command)) {
         //            782|EXIT_ROOM|playerId
         String type = st.nextToken();
         String playerId = st.nextToken();

         finishGame();

         parentApplet.godoriCardLayout.show(parentApplet.cardPanel, "LobbyPanel");
         parentApplet.buttonDefaultSetting();
      } else if("799".equals(command)) {
         // ޽         799|playerId|message
         String playerId = st.nextToken();
         String message = st.nextToken();

         messageBoard(message);
      }
   }
}
