import java.util.*;
import java.awt.*;
import java.awt.event.*;

public class MineCanvas extends Canvas implements Runnable {
   final static int DEFAUL_DELAY_TIME=100;

//   Display         display;

   static 		    int	sqlength = 5;	// length of tetris square
   static final	int	xoffset = 43;	// distance from left
   static 		    int	cols = 10;		// columns
   static 		    int	rows = 19;		// rows
   int		        f[][]; 			// field
   int		        of[][]; 		// old field
   int		        cur_what, newWhat;	// type of current piece
   Block		    curpiece[] = new Block[4];	// current piece
   Block          newPiece[] = new Block[4];
   boolean		    lost;			// lost
   boolean		    needNewPiece;		// need new piece
   Thread		    killMe = null;		// thread that does gravity
   int		        curval, score=0;
   int		        level =1;			// current level of difficulty
   int		        pieces;			// nr of pieces dropped
   boolean 	    justUpdating = false;
   boolean         isStart = false;

   // for double-buffering
   Image offImage=null;
   Graphics offGraphics=null;

   public MineCanvas() {
//   public MineCanvas(Display dis) {
//      display = dis;

      addKeyListener(new KeyAdapter() {
         public void keyPressed(KeyEvent e) {
            switch(e.getKeyCode()) {
               case KeyEvent.VK_LEFT:
                  moveCurrPiece(-1, 0, false);
                  needNewPiece = false;
                  repaint();
               break;
               case KeyEvent.VK_RIGHT:
                  moveCurrPiece(1, 0, false);
                  needNewPiece = false;
                  repaint();
               break;
               case KeyEvent.VK_UP:
                  if(cur_what != 4) {
                     moveCurrPiece(0, 0, true);
                     repaint();
                  }
               break;
               case KeyEvent.VK_DOWN:
                  while(moveCurrPiece(0, -1, false));
                  repaint();
               break;
            }
         }
      });

      setSize(95, 99);
   }

   private Block[] selectNewPiece() {
      Block  temp[] = new Block[4];
      int m = cols / 2;
      Random rand=new Random();

      newWhat =(int) rand.nextInt() % 7;
      newWhat =(newWhat > 0) ? newWhat : newWhat*(-1);

      switch(newWhat) {
         case 0:
            // XXXX		red
            curval = 2;
            temp[0] = new Block(m-1, rows-1, 1, this.cols, this.rows);
            temp[1] = new Block(m-2, rows-1, 1, this.cols, this.rows);
            temp[2] = new Block(m,   rows-1, 1, this.cols, this.rows);
            temp[3] = new Block(m+1, rows-1, 1, this.cols, this.rows);
         break;
         case 1:
            //  X		orange
            // XXX
            curval = 3;
            temp[0] = new Block(m  , rows-2, 5, this.cols, this.rows);
            temp[1] = new Block(m  , rows-1, 5, this.cols, this.rows);
            temp[2] = new Block(m-1, rows-2, 5, this.cols, this.rows);
            temp[3] = new Block(m+1, rows-2, 5, this.cols, this.rows);
         break;
         case 2:
            // XX		???
            //  XX
            curval = 4;
            temp[0] = new Block(m  , rows-2, 2, this.cols, this.rows);
            temp[1] = new Block(m-1, rows-1, 2, this.cols, this.rows);
            temp[2] = new Block(m  , rows-1, 2, this.cols, this.rows);
            temp[3] = new Block(m+1, rows-2, 2, this.cols, this.rows);
         break;
         case 3:
            //  XX		???
            // XX 
            curval = 4;
            temp[0] = new Block(m  , rows-2, 7, this.cols, this.rows);
            temp[1] = new Block(m+1, rows-1, 7, this.cols, this.rows);
            temp[2] = new Block(m  , rows-1, 7, this.cols, this.rows);
            temp[3] = new Block(m-1, rows-2, 7, this.cols, this.rows);
         break;
         case 4:
            //  XX		light blue
            //  XX 
            curval = 2;
            temp[0] = new Block(m-1, rows-1, 3, this.cols, this.rows);
            temp[1] = new Block(m  , rows-1, 3, this.cols, this.rows);
            temp[2] = new Block(m-1, rows-2, 3, this.cols, this.rows);
            temp[3] = new Block(m  , rows-2, 3, this.cols, this.rows);
         break;
         case 5:
            //  XXX		
            //    X 
            curval = 3;
            temp[0] = new Block(m  , rows-1, 6, this.cols, this.rows);
            temp[1] = new Block(m-1, rows-1, 6, this.cols, this.rows);
            temp[2] = new Block(m+1, rows-1, 6, this.cols, this.rows);
            temp[3] = new Block(m+1, rows-2, 6, this.cols, this.rows);
         break;
         case 6:
            //  XXX		yellow
            //  X  
            curval = 3;
            temp[0] = new Block(m  , rows-1, 4, this.cols, this.rows);
            temp[1] = new Block(m+1, rows-1, 4, this.cols, this.rows);
            temp[2] = new Block(m-1, rows-1, 4, this.cols, this.rows);
            temp[3] = new Block(m-1, rows-2, 4, this.cols, this.rows);
         break;
      }
      return temp;
   }

   private void newPiece() {
      Block  old[] = new Block[4];
      old[0] = old[1] = old[2] = old[3] = new Block(-1, -1, 0, this.cols, this.rows);
      this.curpiece = this.newPiece;
      this.cur_what = this.newWhat;
      this.newPiece = selectNewPiece();
      lost = !movePiece(old, curpiece);
   }

   private boolean movePiece(Block from[], Block to[]) {
      outerlabel:
      for(int i=0; i<to.length; i++) {
         if(!to[i].inBounds()) {
            return false;
         }

         if(f[to[i].getX()][to[i].getY()] != 0) {	// it's taken
            for(int j=0; j<from.length; j++) {
               if(to[i].isEqual(from[j])) {
                  continue outerlabel;		// but by a from
               }
            }
            return false;	// no can do
         }
      }

      for(int i=0; i<from.length; i++) {
         if(from[i].inBounds()) {
            f[from[i].getX()][from[i].getY()] = 0;
         }
      }

      for(int i=0; i<to.length; i++) {
         f[to[i].getX()][to[i].getY()] = to[i].getColor();
      }

      return true;
   }

   private synchronized boolean moveCurrPiece(int byx, int byy, boolean rotate) {
      Block newpos[] = new Block[4];

      for(int i=0;i<4;i++) {
         if(rotate) {
            int dx = curpiece[i].getX() - curpiece[0].getX();
            int dy = curpiece[i].getY() - curpiece[0].getY();
            newpos[i] = new Block(curpiece[0].getX() - dy,
                                  curpiece[0].getY() + dx,
                                  curpiece[i].getColor(), this.cols, this.rows);
         } else {
            newpos[i] = new Block(curpiece[i].getX() + byx,
                                  curpiece[i].getY() + byy,
                                  curpiece[i].getColor(), this.cols, this.rows);
         }
      }
      if(!movePiece(curpiece, newpos)) {
         return false;
      }
      curpiece = newpos;

      return true;
   }

   private void removeLines() {
      outerlabel:
      for(int j=0; j<rows; j++) {
         for(int i=0; i<cols; i++) {
            if(f[i][j] == 0) {
               continue outerlabel;
            }
         }

         for(int k=j; k<rows-1; k++) {
            for(int i=0; i<cols; i++) {
               f[i][k] = f[i][k+1];
            }
         }
         j--;
      }
   }

   public void  newGame() {	
      this.stop();

      sqlength = 5;
      cols = 10;
      rows = 19;

      f = new int[cols][rows+4];	
      of = new int[cols][rows+4];	

      for(int i=0; i<cols; i++) {
         for(int j=0; j<rows+4; j++) {
            f[i][j] = 0; 
            of[i][j] = -1;
         }
      }

      level = 1;
      score = 0;
      pieces = 0;
      curval = -1;
      needNewPiece = true;
      this.newPiece = this.selectNewPiece();
      lost = false;

      this.isStart = false;
      killMe = new Thread(this);
      killMe.start();
   }

   public void start() {
//      display.setCurrent(this);
      this.isStart = true;
      repaint();
   }

   public synchronized void stop() {
      if(this.killMe != null && this.killMe.isAlive()) {
         this.killMe = null;
         this.lost = true;
      }
   }

   public void run() {
      int delayTime[] = new int[] { 400, 370, 330, 300, 270,
                                    250, 230, 200, 170, 130 };
      while(!lost) {
         try {
            if((level >=1 )||(level <= delayTime.length)) {
               Thread.sleep(delayTime[level-1]);
            } else {
               Thread.sleep(DEFAUL_DELAY_TIME);
            }
         } catch(InterruptedException e) {
         }

         if(needNewPiece) {
            if(curval > 0) {
               score += curval;
               pieces++;
               level = 1 + pieces / 30;
            }
            removeLines();
            newPiece();
            needNewPiece = false;
         } else {
            needNewPiece = !moveCurrPiece(0, -1, false);	
         }
         repaint();
      }
      killMe = null;
   }

   private void drawNextPiece(Graphics g) {
      g.drawString("Next" , 3, 5+10);
      int startx= 8, starty=22;

      switch(newWhat) {
         case 0:
            // XXXX		red
            g.fillRect(startx, starty+3, sqlength*4, sqlength*1);
            this.setBlockColor(g, 0);
            g.drawRect(startx, starty+3, sqlength, sqlength);
            g.drawRect(startx+sqlength, starty+3, sqlength, sqlength);
            g.drawRect(startx+sqlength*2, starty+3, sqlength, sqlength);
            g.drawRect(startx+sqlength*3, starty+3, sqlength, sqlength);
         break;
         case 1:
            //  X		orange
            // XXX
            g.fillRect(startx +sqlength+3, starty, sqlength, sqlength);
            g.fillRect(startx+3, starty+sqlength, sqlength*3, sqlength*1);
            this.setBlockColor(g, 0);
            g.drawRect(startx+3+sqlength, starty, sqlength, sqlength);
            g.drawRect(startx+3, starty+sqlength, sqlength, sqlength);
            g.drawRect(startx+3+sqlength, starty+sqlength, sqlength, sqlength);
            g.drawRect(startx+3+sqlength*2, starty+sqlength, sqlength, sqlength);
         break;
         case 2:
            // XX		???
            //  XX
            g.fillRect(startx +3, starty, sqlength*2, sqlength);
            g.fillRect(startx+sqlength+3, starty+sqlength, sqlength*2, sqlength*1);
            this.setBlockColor(g, 0);
            g.drawRect(startx+3, starty, sqlength, sqlength);
            g.drawRect(startx+sqlength+3, starty, sqlength, sqlength);
            g.drawRect(startx+3+sqlength, starty+sqlength, sqlength, sqlength);
            g.drawRect(startx+3+sqlength*2, starty+sqlength, sqlength, sqlength);
         break;
         case 3:
            //  XX		???
            // XX 
            g.fillRect(startx +sqlength+3, starty, sqlength*2, sqlength);
            g.fillRect(startx+3, starty+sqlength, sqlength*2, sqlength*1);
            this.setBlockColor(g, 0);
            g.drawRect(startx+3+sqlength, starty, sqlength, sqlength);
            g.drawRect(startx+3+sqlength*2, starty, sqlength, sqlength);
            g.drawRect(startx+3, starty+sqlength, sqlength, sqlength);
            g.drawRect(startx+3+sqlength, starty+sqlength, sqlength, sqlength);
         break;
         case 4:
            //  XX		light blue
            //  XX 
            g.fillRect(startx +sqlength+3, starty, sqlength*2, sqlength*2);
            this.setBlockColor(g, 0);
            g.drawRect(startx +sqlength+3, starty, sqlength*2, sqlength*2);
            g.drawLine(startx +sqlength*2+3, starty, startx +sqlength*2+3, starty+sqlength*2);
            g.drawLine(startx +sqlength+3, starty+sqlength, startx +sqlength*3+3, starty+sqlength);
         break;
         case 5:
            //  XXX		
            //    X 
            g.fillRect(startx +3, starty, sqlength*3, sqlength);
            g.fillRect(startx+sqlength*2+3, starty+sqlength, sqlength, sqlength*1);
            this.setBlockColor(g, 0);
            g.drawRect(startx+3, starty, sqlength, sqlength);
            g.drawRect(startx+3+sqlength, starty, sqlength, sqlength);
            g.drawRect(startx+3+sqlength*2, starty, sqlength, sqlength);
            g.drawRect(startx+3+sqlength*2, starty+sqlength, sqlength, sqlength);
         break;
         case 6:
            //  XXX		yellow
            //  X  
            g.fillRect(startx +3, starty, sqlength*3, sqlength);
            g.fillRect(startx+3, starty+sqlength, sqlength, sqlength*1);
            this.setBlockColor(g, 0);
            g.drawRect(startx+3, starty, sqlength, sqlength);
            g.drawRect(startx+3+sqlength, starty, sqlength, sqlength);
            g.drawRect(startx+3+sqlength*2, starty, sqlength, sqlength);
            g.drawRect(startx+3, starty+sqlength, sqlength, sqlength);
         break;
      }
   }

   public void setBlockColor(Graphics g, int color) {
      switch(color) {
         case 0: g.setColor(new Color(255, 255, 255));    break;			
/*
         case 1: g.setColor(255,0,0);        break;			
         case 2: g.setColor(0,200,0);        break;
         case 3: g.setColor(0,200,255);      break;
         case 4: g.setColor(255,255,0);      break;
         case 5: g.setColor(255,150,0);      break;
         case 6: g.setColor(210,0,240);      break;
         case 7: g.setColor(40,0,240);       break;                      
         case 8: g.setColor(0,0,0);          break;
*/
         default : g.setColor(new Color(0, 0, 0));        break;
      }
   }

   public void update(Graphics g) {
      justUpdating = true;
      paint(g);
   }

   public synchronized void paint(Graphics g) {
      try {
         if(offGraphics == null) {
            offImage = createImage(getSize().width, getSize().height);
            offGraphics = offImage.getGraphics();
         }

         if(isStart) {
            g.setFont(new Font("Dialog", Font.PLAIN, 12));
            g.drawString("JAVA TETRIS",10, 40+20);
            g.drawRect(0,0,95,99);
         } else {
/*
            this.setBlockColor(g, 0);
            g.fillRect(0,0,95,99);
            this.setBlockColor(g, 8);
            g.drawRect(0,0,95,99);
            g.drawRect(xoffset-1, 2, sqlength*cols+1, sqlength*rows+1);
            this.setBlockColor(g, 8);
            g.setFont(new Font("Dialog", Font.PLAIN, 9));
            offGraphics.drawString("Score", 3, 40+10);
            offGraphics.drawString(""+score, 3, 55+10);
            offGraphics.drawString("Level", 3, 70+10);
            offGraphics.drawString(""+level, 3, 85+10);
            this.drawNextPiece(g);

            for(int i=0; i<cols; i++) {
               for(int j=0; j<rows; j++) {
                  if((!justUpdating)||(of[i][rows-1-j] != -1)||(of[i][rows-1-j] != f[i][rows-1-j])) {
                     this.setBlockColor(g, f[i][rows-1-j]);		    	    
                     g.fillRect(xoffset+sqlength*i, 3+sqlength*j, sqlength, sqlength);
                     this.setBlockColor(g, 0);
                     g.drawRect(xoffset+sqlength*i, 3+sqlength*j, sqlength, sqlength);
                  }
                  of[i][rows-1-j] = f[i][rows-1-j];
               }
            }
            justUpdating = false;
*/
            this.setBlockColor(offGraphics, 0);
            offGraphics.fillRect(0,0,95,99);
            this.setBlockColor(offGraphics, 8);
            offGraphics.drawRect(0,0,95,99);
            offGraphics.drawRect(xoffset-1, 2, sqlength*cols+1, sqlength*rows+1);
            this.setBlockColor(offGraphics, 8);

            g.setFont(new Font("Dialog", Font.PLAIN, 10));
            offGraphics.drawString("Score", 3, 40+10);
            offGraphics.drawString(""+score, 3, 55+10);
            offGraphics.drawString("Level", 3, 70+10);
            offGraphics.drawString(""+level, 3, 85+10);
            this.drawNextPiece(offGraphics);

            for(int i=0; i<cols; i++) {
               for(int j=0; j<rows; j++) {
                  if((!justUpdating)||(of[i][rows-1-j] != -1)||(of[i][rows-1-j] != f[i][rows-1-j])) {
                     this.setBlockColor(offGraphics, f[i][rows-1-j]);		    	    
                     offGraphics.fillRect(xoffset+sqlength*i, 3+sqlength*j, sqlength, sqlength);
                     this.setBlockColor(offGraphics, 0);
                     offGraphics.drawRect(xoffset+sqlength*i, 3+sqlength*j, sqlength, sqlength);
                  }

                  of[i][rows-1-j] = f[i][rows-1-j];
               }
            }
            justUpdating = false;

            g.drawImage(offImage, 0, 0, this);
         }
      } catch(Exception e) {
         System.out.println(e.getMessage());
         System.out.println(e.toString());
      }
   }
}
