/*
 * Project: MW Dilemma Game
 *    File: ClientLobby.java
 *    Date: 2 10, 2001
 * Authhor: Yongwoo's Park.
 */

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;
import java.util.Date;
import java.util.Vector;
import java.util.StringTokenizer;
import java.util.zip.ZipEntry;
import java.util.zip.ZipInputStream;

public class ClientLobby extends Applet implements Runnable {
   Thread clientLobbyThread = null;
   private AppletContext appletContext = null;

   static String KAWUI_BAWUI_BO_GAME_SERVER;
   final static int KAWUI_BAWUI_BO_GAME_PORT=4001;

   public Socket socket=null;
   public BufferedReader is=null;
   public PrintWriter os=null;

   String roomId=null;
   String groupId=null;
   String playerId=null;
   String playerName=null;
   String exitPageURL=null;

   Image logoImage=null;
   Image backgroundImage=null;
   ImageCanvas backgroundCanvas=null;

   int roomButtonX[] = { 104, 153, 203, 253, 303, 354 };
   ImageButton roomButton[]=null;
   Image roomButtonImage[][]=null;

   ImageButton joinButton=null;
   ImageButton loginButton=null;
   ImageButton regiButton=null;
   ImageButton teamListButton=null;
   ImageButton lobbyInfoButton=null;
   ImageButton exitButton=null;

   final static int IMAGE_NUM=37;
   Image joinButtonImage[]=null;
   Image loginButtonImage[]=null;
   Image regiButtonImage[]=null;
   Image teamListButtonImage[]=null;
   Image lobbyInfoButtonImage[]=null;
   Image exitButtonImage[]=null;

   TextField roomField=null;
   TextField idField=null;
   TextField passwordField=null;

   TextArea chatArea=null;
   TextField chatField=null;
   Choice chatChoice=null;
   List infoList=null;

   CardLayout godoriCardLayout=null;
   Panel cardPanel=null;
   Panel lobbyPanel=null;
   ClientRoom boardPanel=null;

//////////////////////////////////////////////////
   int countImagesLoaded=0;
   Toolkit toolkit=null;
   MediaTracker mwTrack=null;
   LoadingBarWindow loadingBarWindow=null;

   public void init() {
      KAWUI_BAWUI_BO_GAME_SERVER = getCodeBase().getHost();

      groupId = getParameter("group");
      playerId = getParameter("id");
      playerName = getParameter("name");
      exitPageURL = getParameter("exitPageURL");

      if(groupId == null) {
        groupId = "group#"+hashCode();
      }
      if(playerId == null) {
         playerId = ""+new Date().getTime();
      }
      if(playerName == null) {
        playerName = playerId;
      }
      if(exitPageURL == null) {
        exitPageURL = "http://www.baeoom.com";
      }

//////////////////////////////////////////////

      logoImage = getImage(getDocumentBase(), "images/logo.jpg");
      if(mwTrack == null) {
         mwTrack = new MediaTracker(this);
      }
      mwTrack.addImage(logoImage, 0);
      try {
         mwTrack.waitForAll();
      } catch(InterruptedException e) {
         System.out.println(e);
      }

      loadingBarWindow = new LoadingBarWindow((Frame)this.getParent(),
                                              logoImage, "Loading images...");
      loadingBarWindow.show();

      loadImages();

//      loadingBarWindow.setMessage("Loading sounds...");
//      loadingBarWindow.setStatusLevel(0);
//      loadSounds();

      loadingBarWindow.setMessage("Connecting...");
      loadingBarWindow.setStatusLevel(0);
//////////////////////////////////////////////

      godoriCardLayout = new CardLayout();
      cardPanel = new Panel(godoriCardLayout);

      lobbyPanel = initLobbyPanel();
      boardPanel = new ClientRoom(ClientLobby.this);

      loadingBarWindow.setStatusLevel(50);
      connect();

      cardPanel.add(lobbyPanel, "LobbyPanel");
      cardPanel.add(boardPanel, "BoardPanel");

      setLayout(new BorderLayout());
      add("Center", cardPanel);

      godoriCardLayout.show(cardPanel, "LobbyPanel");

      defaultButtonSetting();

      loadingBarWindow.setStatusLevel(100);
      loadingBarWindow.dispose();
   }

   public Panel initLobbyPanel() {
      lobbyPanel = new Panel(null);

      backgroundCanvas = new ImageCanvas(backgroundImage, lobbyPanel, 800, 555);

      roomButton = new ImageButton[6];
      for(int i=0;i<6;i++) {
         roomButton[i] = new ImageButton(roomButtonImage[i][0], roomButtonImage[i][1], roomButtonImage[i][2]);
      }

      joinButton = new ImageButton(joinButtonImage[0], joinButtonImage[1], joinButtonImage[2]);
      loginButton = new ImageButton(loginButtonImage[0], loginButtonImage[1], loginButtonImage[2]);
      regiButton = new ImageButton(regiButtonImage[0], regiButtonImage[1], regiButtonImage[2]);
      teamListButton = new ImageButton(teamListButtonImage[0], teamListButtonImage[1], teamListButtonImage[2]);
      lobbyInfoButton = new ImageButton(lobbyInfoButtonImage[0], lobbyInfoButtonImage[1], lobbyInfoButtonImage[2]);
      exitButton = new ImageButton(exitButtonImage[0], exitButtonImage[1], exitButtonImage[2]);

      roomField = new TextField();
      idField = new TextField();
      passwordField = new TextField();
      passwordField.setEchoChar('*');
      chatArea = new TextArea();
      chatField = new TextField();
      chatChoice = new Choice();
      chatChoice.add("BROADCAST");
      chatChoice.add("GROUPCAST");
      infoList = new List();

      backgroundCanvas.setBounds(0, 0, 800, 555);

      int roomButtonX[] = { 104, 153, 203, 253, 303, 354 };
      for(int i=0;i<6;i++) {
         roomButton[i].setBounds(104+i*50, 117, 50, 48);
      }
      joinButton.setBounds(306, 167, 92, 27);
      loginButton.setBounds(425, 167, 71, 27);
      regiButton.setBounds(495, 167, 71, 27);
      teamListButton.setBounds(568, 167, 71, 27);
      lobbyInfoButton.setBounds(639, 167, 71, 27);
      exitButton.setBounds(702, 483, 26, 26);

      roomField.setBounds(116, 172, 178, 19);
      idField.setBounds(457, 133, 96, 19);
      passwordField.setBounds(609, 133, 94, 19);
      chatArea.setBounds(112, 222, 280, 242);
      chatField.setBounds(112, 474, 176, 19);
      chatChoice.setBounds(300, 474, 92, 19);
      infoList.setBounds(425, 222, 285, 242);

      for(int i=0;i<6;i++) {
         roomButton[i].setBounds(104+i*50, 117, 50, 48);
         lobbyPanel.add(roomButton[i]);
      }
      lobbyPanel.add(joinButton);
      lobbyPanel.add(loginButton);
      lobbyPanel.add(regiButton);
      lobbyPanel.add(teamListButton);
      lobbyPanel.add(lobbyInfoButton);
      lobbyPanel.add(exitButton);

      lobbyPanel.add(roomField);
      lobbyPanel.add(idField);
      lobbyPanel.add(passwordField);
      lobbyPanel.add(chatArea);
      lobbyPanel.add(chatField);
      lobbyPanel.add(chatChoice);
      lobbyPanel.add(infoList);

      lobbyPanel.add(backgroundCanvas);

      ActionListener al = new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            String message=null;
            if(e.getSource() == chatField) {
               String chatStr = chatField.getText().trim();
               chatField.setText("");

               if("".equals(chatStr)) {
                  return;
               }

               if("BROADCAST".equals(chatChoice.getSelectedItem())) {
                  message = "100|BROADCAST|"+playerId+"|*|"+chatStr;
               } else if("GROUPCAST".equals(chatChoice.getSelectedItem())) {
                  if(groupId == null) {
                     message = "100|BROADCAST|"+playerId+"|*|"+chatStr;
                  } else {
                     message = "102|GROUPCAST|"+playerId+"|"+groupId+"|"+chatStr;
                  }
               } else {
                  message = "100|BROADCAST|"+playerId+"|*|"+chatStr;
               }
               sendToServer(message);
            } else if(e.getSource() == idField) {
               chatField.requestFocus();
            } else if(e.getSource() == passwordField) {
               chatField.requestFocus();
            } else if(e.getSource() == roomButton[0]) {
               roomId = "Room#1";
               roomField.setText("Room#1");
               sendToServer("112|"+playerId+"|"+"Room#1");
            } else if(e.getSource() == roomButton[1]) {
               roomId = "Room#2";
               roomField.setText("Room#2");
               sendToServer("112|"+playerId+"|"+"Room#2");
            } else if(e.getSource() == roomButton[2]) {
               roomId = "Room#3";
               roomField.setText("Room#3");
               sendToServer("112|"+playerId+"|"+"Room#3");
            } else if(e.getSource() == roomButton[3]) {
               roomId = "Room#4";
               roomField.setText("Room#4");
               sendToServer("112|"+playerId+"|"+"Room#4");
            } else if(e.getSource() == roomButton[4]) {
               roomId = "Room#5";
               roomField.setText("Room#5");
               sendToServer("112|"+playerId+"|"+"Room#5");
            } else if(e.getSource() == roomButton[5]) {
               roomId = "Room#6";
               roomField.setText("Room#6");
               sendToServer("112|"+playerId+"|"+"Room#6");
            } else if(e.getSource() == joinButton) {
               String roomId = roomField.getText();
               if((roomId != null)&&(!"".equals(roomId))) {
                  sendToServer("122|"+playerId+"|"+roomId);
//                  godoriCardLayout.show(cardPanel, "BoardPanel");
//                  sendToServer("580|JOIN_ROOM|"+playerId);
               }
            } else if(e.getSource() == loginButton) {
               String groupId = idField.getText().trim();
               String groupPass = passwordField.getText().trim();

               idField.setText(groupId);
               passwordField.setText(groupPass);
               if((groupId != null)&&(!"".equals(groupId))&&(groupPass != null)&&(!"".equals(groupPass))) {
                  sendToServer("126|"+playerId+"|"+groupId+"|"+groupPass);
//                  godoriCardLayout.show(cardPanel, "BoardPanel");
//                  sendToServer("580|JOIN_ROOM|"+playerId);
               } else {
                  WarningDialog w = new WarningDialog((Frame)(ClientLobby.this.getParent()),
                                                      "â!",
                                                      "̵  ȣ Էϼ.");
                  w.show();
               }
            } else if(e.getSource() == regiButton) {
               String groupId = idField.getText().trim();
               String groupPass = passwordField.getText().trim();

               idField.setText(groupId);
               passwordField.setText(groupPass);
               if((groupId != null)&&(!"".equals(groupId))&&(groupPass != null)&&(!"".equals(groupPass))) {
                  sendToServer("124|"+playerId+"|"+groupId+"|"+groupPass);
               } else {
                  WarningDialog w = new WarningDialog((Frame)(ClientLobby.this.getParent()),
                                                      "â!",
                                                      "̵  ȣ Էϼ.");
                  w.show();
               }
            } else if(e.getSource() == teamListButton) {
                  sendToServer("114|"+playerId);
//               if((groupId != null)&&(!"".equals(groupId))) {
//                  sendToServer("116|"+playerId+"|"+groupId);
//               } else {
//                  WarningDialog w = new WarningDialog((Frame)(ClientLobby.this.getParent()),
//                                                      "â!",
//                                                      "̵  ȣ Էϼ.");
//                  w.show();
//               }
            } else if(e.getSource() == lobbyInfoButton) {
               sendToServer("112|"+playerId+"|"+"");
            } else if(e.getSource() == exitButton) {
               sendToServer("182|LEAVE|"+playerId);
               try {
                  URL setRestartURL = new URL(exitPageURL);
                  getAppletContext().showDocument(setRestartURL);
               } catch(MalformedURLException ee) {
               }
            }
         }
      };
      roomField.setText("Room#1");
      roomField.setEnabled(false);

      for(int i=0;i<6;i++) {
         roomButton[i].addActionListener(al);
      }
      chatField.addActionListener(al);
      idField.addActionListener(al);
      passwordField.addActionListener(al);

      joinButton.addActionListener(al);
      loginButton.addActionListener(al);
      regiButton.addActionListener(al);
      teamListButton.addActionListener(al);
      lobbyInfoButton.addActionListener(al);
      exitButton.addActionListener(al);

      FocusListener fl = new FocusAdapter() {
         public void focusGained(FocusEvent e) {
            chatField.requestFocus();
         }
      };

      roomField.addFocusListener(fl);
      chatArea.addFocusListener(fl);
      infoList.addFocusListener(fl);
      chatArea.addFocusListener(fl);

      chatField.requestFocus();

      return(lobbyPanel);
   }

   public void buttonDefaultSetting() {
   }

   private void connect() {
      try {
         socket = new Socket(KAWUI_BAWUI_BO_GAME_SERVER, KAWUI_BAWUI_BO_GAME_PORT);
         is = new BufferedReader(new InputStreamReader(socket.getInputStream()));
         os = new PrintWriter(socket.getOutputStream(), true);

         String receive=null;
         StringTokenizer st = null;
         String command = null;
         try {
            receive = receiveMessage();  // "UserName" is read
            sendToServer(playerId);

            socket.setSoTimeout(10);   // ʹ 10ms  ٸ , ޽ Ȯ ..
         } catch(Exception e) { //Unknown error. Throw tantrum.
            chatArea.append("ܹ߻: "+e+"\n");
         }
      } catch(UnknownHostException e) {
         chatArea.append("ܹ߻: "+e+"\n");
         stop();
         return;
      } catch(SocketException e) {
         chatArea.append("ܹ߻: "+e+"\n");
         stop();
         return;
      } catch(IOException e) {
         chatArea.append("ܹ߻: "+e+"\n");
         stop();
         return;
      }
   }

   public synchronized void start() {
      if(clientLobbyThread == null) {
         try {
            if(socket != null) {
               if(is == null) {
                  is = new BufferedReader(new InputStreamReader(socket.getInputStream()));
               }
               if(os == null) {
                  os = new PrintWriter(socket.getOutputStream(), true);
               }
            } else {
               connect();
            }
            clientLobbyThread = new Thread(this);
            clientLobbyThread.start();
         } catch(IOException e) {
         }
      }
   }

   public synchronized void stop() {
      if(clientLobbyThread != null) {
         clientLobbyThread.stop();
         clientLobbyThread = null;
      }
   }

   public synchronized void destroy() {
      try {
         if(is != null) {
            is.close();
            is = null;
         }
      } catch(Exception e) {
         System.out.println(e);
      }
      try {
         if(os != null) {
            os.close();
            os = null;
         }
      } catch(Exception e) {
         System.out.println(e);
      }
      try {
         if(socket != null) {
            socket.close();
            socket = null;
         }
      } catch(Exception e) {
         System.out.println(e);
      }
   }

   public void sendToServer(String message) {
      if(message != null) {
         os.println(message);
         os.flush();

         if(os.checkError()) {
         }
         System.out.println("Send: "+message);
      }
   }

   public String receiveMessage() throws SocketException {
      String message = null;
      try {
         message = is.readLine();
         System.out.println("Receive: "+message);
      } catch(SocketException e) {
         throw(e);
      } catch(Exception e) {
         return "";
      }
      return message;
   }

   public void messageBoard(String message) {
      chatArea.append("\n[޽] "+message+"\n\n");
   }

   public void updateRoomList(String roomIds) {
      if(roomIds == null) {
         return;
      }
   }

   public void updateUserList(String roomId, String playerIds) {
      infoList.removeAll();
      infoList.add("["+roomId+"]   Ʈ");
      infoList.add("----------");
      if((roomId == null)||(playerIds == null)||("".equals(roomId))||("".equals(playerIds))) {
         infoList.add("ڰ ϴ.");
         return;
      }
      StringTokenizer st = new StringTokenizer(playerIds, ",");
      while(st.hasMoreTokens()) {
         infoList.add(st.nextToken());
      }
   }

   public void updateGroupList(String groupIds) {
      infoList.removeAll();
      infoList.add("["+groupId+"] ׷ Ʈ");
      infoList.add("----------");
      if((groupIds == null)||("".equals(groupIds))) {
         infoList.add("ϵ ׷ ϴ.");
         return;
      }
      StringTokenizer st = new StringTokenizer(groupIds, ",");
      while(st.hasMoreTokens()) {
         infoList.add(st.nextToken());
      }
   }

   public void updateGroupUserList(String groupId, String playerIds) {
      infoList.removeAll();
      infoList.add("["+groupId+"] ׷  Ʈ");
      infoList.add("----------");
      if((groupId == null)||(playerIds == null)||("".equals(groupId))||("".equals(playerIds))) {
         infoList.add("ڰ ϴ.");
         return;
      }
      StringTokenizer st = new StringTokenizer(playerIds, ",");
      while(st.hasMoreTokens()) {
         infoList.add(st.nextToken());
      }
   }

   public void defaultButtonSetting() {
      joinButton.setEnabled(false);

      idField.setEnabled(true);
      passwordField.setEnabled(true);

      loginButton.setEnabled(true);
      regiButton.setEnabled(true);
      teamListButton.setEnabled(true);
      lobbyInfoButton.setEnabled(true);

      exitButton.setEnabled(true);
   }

   public void loginButtonSetting() {
      joinButton.setEnabled(true);

      idField.setEnabled(false);
      passwordField.setEnabled(false);

      loginButton.setEnabled(false);
      regiButton.setEnabled(false);
      teamListButton.setEnabled(true);
      lobbyInfoButton.setEnabled(true);

      exitButton.setEnabled(true);
   }

   public void run() {
      String receive=null;
      while(Thread.currentThread() == clientLobbyThread) {
         try {
            Thread.sleep(100);
         } catch(InterruptedException e) {
         }
         try {
            receive = receiveMessage();
            if((receive == null)||("".equals(receive))) {
               continue;
            }
            processMessage(receive);
            boardPanel.processMessage(receive);
         } catch(SocketException e) { //Stream doesn't exist.
            e.printStackTrace();
            stop();
            return;
         } catch(Exception e) { //Unknown error. Throw tantrum.
            e.printStackTrace();
         }
      }
   }

   public void processMessage(String receive) {
      StringTokenizer st = new StringTokenizer(receive, "|");
      String command = st.nextToken();
      if("300".equals(command)) {         // εĳ ä
         // εĳ ä  300|BROADCAST|playerId|*|chatStr
         String type = st.nextToken();
         String playerId = st.nextToken();
         String target = st.nextToken();
         String chatStr = st.nextToken();

         chatArea.append(chatStr+"\n");
      } else if("302".equals(command)) {         // εĳ ä
         // εĳ ä  302|GROUPCAST|playerId|groupId|chatStr
         String type = st.nextToken();
         String playerId = st.nextToken();
         String groupId = st.nextToken();
         String chatStr = st.nextToken();

         chatArea.append(chatStr+"\n");
      } else if("304".equals(command)) {         // εĳ ä
         // εĳ ä  304|UNICAST|playerId|toPlayerId|chatStr
         String type = st.nextToken();
         String fromPlayerId = st.nextToken();
         String toPlayerId = st.nextToken();
         String chatStr = st.nextToken();

         chatArea.append(chatStr+"\n");
      } else if("310".equals(command)) {
         // 븮Ʈ           310|playerId|roomId#1,roomId#2,,roomId#n
         String playerId = st.nextToken();
         String roomIds = st.nextToken();

         updateRoomList(roomIds);
      } else if("312".equals(command)) {
         // ڸƮ       312|playerId|roomId|playerId#1,playerId#2,,playerId#n
         String playerId = st.nextToken();
         String roomId = st.nextToken();
         String playerIds = null;
         try {
            playerIds = st.nextToken();
         } catch(Exception e) {
            System.out.println("e: "+e);
         }

         updateUserList(roomId, playerIds);
      } else if("314".equals(command)) {
         // ׷츮Ʈ         314|playerId|groupId#1,groupId#2,,groupId#n
         String playerId = st.nextToken();
         String groupIds = null;
         try {
            groupIds = st.nextToken();
         } catch(Exception e) {
            System.out.println("e: "+e);
         }

         updateGroupList(groupIds);
      } else if("316".equals(command)) {
         // ׷ڸƮ   316|playerId|groupId|playerId#1,playerId#2,,playerId#n
         String playerId = st.nextToken();
         String groupId = st.nextToken();
         String playerIds = null;
         try {
            playerIds = st.nextToken();
         } catch(Exception e) {
            System.out.println("e: "+e);
         }

         updateGroupUserList(groupId, playerIds);
      } else if("320".equals(command)) {
         // 游       320|playerId|roomId|[SUCCESS|FAIL]
         String playerId = st.nextToken();
         String roomId = st.nextToken();
         String result = st.nextToken();
      } else if("322".equals(command)) {
         //          322|playerId|roomId|[SUCCESS|FULL|NOROOM]
         String playerId = st.nextToken();
         String roomId = st.nextToken();
         String result = st.nextToken();

         if("SUCCESS".equals(result)) {
            this.roomId = roomId;
            godoriCardLayout.show(cardPanel, "BoardPanel");
         } else {
            messageBoard("["+roomId+"]  Ⱑ Ͽϴ.");
         }
      } else if("324".equals(command)) {
         // ׷        324|playerId|groupId|[SUCCESS|FAIL]
         String playerId = st.nextToken();
         String groupId = st.nextToken();
         String result = st.nextToken();

         if("SUCCESS".equals(result)) {
            this.groupId = groupId;
            messageBoard("["+groupId+"] ׷  Ͽϴ.");

            loginButtonSetting();
         } else {
            messageBoard("["+groupId+"] ׷ ϴµ Ͽϴ.");
         }
      } else if("326".equals(command)) {
         // ׷ ϱ   326|playerId|groupId|[SUCCESS|FAIL]
         String playerId = st.nextToken();
         String groupId = st.nextToken();
         String result = st.nextToken();

         if("SUCCESS".equals(result)) {
            this.groupId = groupId;
            messageBoard("["+groupId+"] ׷쿡 ε Ͽϴ.");

            loginButtonSetting();
         } else {
            messageBoard("["+groupId+"] ׷쿡 α ϴµ Ͽϴ.");
         }
      } else if("380".equals(command)) {
         //            380|JOIN|playerId
         String type = st.nextToken();
         String playerId = st.nextToken();
      } else if("382".equals(command)) {
         //            382|LEAVE|playerId
         String type = st.nextToken();
         String playerId = st.nextToken();
      } else if("399".equals(command)) {
         // ޽         399|playerId|message
         String playerId = st.nextToken();
         String message = st.nextToken();

         messageBoard(message);
      }
   }

   private void getImagesFromZip() {
      try {
         URL url = new URL(getDocumentBase(), "images/images.zip");

         DataInputStream bi = new DataInputStream(url.openStream());
         ZipInputStream zi = new ZipInputStream(bi);
         ZipEntry zip = zi.getNextEntry();
         String name = zip.getName();
         int size = (int)zip.getSize();
         byte buffer[] = null;

         if(toolkit == null) {
            toolkit = Toolkit.getDefaultToolkit();
         }

         while(zip != null) {
            name = zip.getName();
            size = (int)zip.getSize();
            buffer = new byte[size];
            int pos = 0;
            int bytesRead;
            for(;size>0;size-=bytesRead) {
               bytesRead = zi.read(buffer, pos, size);
               pos += bytesRead;
            }

            boolean okFlag = false;
            if("game-out.gif".equals(name)) {
               backgroundImage = toolkit.createImage(buffer);
               mwTrack.addImage(backgroundImage, 0);
               okFlag = true;
            }
            for(int i=0;(!okFlag)&&(i<6);i++) {
               for(int j=0;(!okFlag)&&(j<3);j++) {
                  if((""+(i+1)+"b-"+(j+1)+".gif").equals(name)) {
                     roomButtonImage[i][j] = toolkit.createImage(buffer);
                     mwTrack.addImage(roomButtonImage[i][j], 0);
                     okFlag = true;
                  }
               }
            }
            for(int i=0;(!okFlag)&&(i<3);i++) {
               if(("i-a"+(i+1)+".gif").equals(name)) {
                  joinButtonImage[i] = toolkit.createImage(buffer);
                  mwTrack.addImage(joinButtonImage[i], 0);
                  okFlag = true;
                  break;
               }
            }
            for(int i=0;(!okFlag)&&(i<3);i++) {
               if(("i-b"+(i+1)+".gif").equals(name)) {
                  loginButtonImage[i] = toolkit.createImage(buffer);
                  mwTrack.addImage(loginButtonImage[i], 0);
                  okFlag = true;
                  break;
               }
            }
            for(int i=0;(!okFlag)&&(i<3);i++) {
               if(("i-c"+(i+1)+".gif").equals(name)) {
                  regiButtonImage[i] = toolkit.createImage(buffer);
                  mwTrack.addImage(regiButtonImage[i], 0);
                  okFlag = true;
                  break;
               }
            }
            for(int i=0;(!okFlag)&&(i<3);i++) {
               if(("i-d"+(i+1)+".gif").equals(name)) {
                  teamListButtonImage[i] = toolkit.createImage(buffer);
                  mwTrack.addImage(teamListButtonImage[i], 0);
                  okFlag = true;
                  break;
               }
            }
            for(int i=0;(!okFlag)&&(i<3);i++) {
               if(("i-e"+(i+1)+".gif").equals(name)) {
                  lobbyInfoButtonImage[i] = toolkit.createImage(buffer);
                  mwTrack.addImage(lobbyInfoButtonImage[i], 0);
                  okFlag = true;
                  break;
               }
            }
            for(int i=0;(!okFlag)&&(i<3);i++) {
               if(("in-quit"+(i+1)+".gif").equals(name)) {
                  exitButtonImage[i] = toolkit.createImage(buffer);
                  mwTrack.addImage(exitButtonImage[i], 0);
                  okFlag = true;
                  break;
               }
            }
            if(okFlag == true) {
               countImagesLoaded++;
               int level = (int)(((double)countImagesLoaded
                                / (double)(IMAGE_NUM))
                               * (double)100);
               loadingBarWindow.setStatusLevel(level);
            }
            zip = zi.getNextEntry();
        }
      } catch(Exception anyException) {
         anyException.printStackTrace();
      }
   }

   public AudioClip getAudioClip(URL url, String name) {
      AudioClip clip = super.getAudioClip(url, name);
      clip.play();
      clip.stop();

      return(clip);
   }

   private void loadImages() {
      if(mwTrack == null) {
         mwTrack = new MediaTracker(this);
      }
      roomButtonImage = new Image[6][3];
      joinButtonImage = new Image[3];
      loginButtonImage = new Image[3];
      regiButtonImage = new Image[3];
      teamListButtonImage = new Image[3];
      lobbyInfoButtonImage = new Image[3];
      exitButtonImage = new Image[3];

      try {
         getImagesFromZip();
         mwTrack.waitForID(0);
      } catch(Exception ex) {
         System.out.println("Exception:"+ex);
      }
   }

   private void loadSounds() {
      int level=0, countSoundsLoaded = 0;
/*
      timerClip = getAudioClip(getDocumentBase(), "audio/timer.au");
      level = (int)(((double)(++countSoundsLoaded) / (double)6) * (double)100);
      loadingBarWindow.setStatusLevel(level);

      nextClip = getAudioClip(getDocumentBase(), "audio/next.au");
      level = (int)(((double)(++countSoundsLoaded) / (double)6) * (double)100);
      loadingBarWindow.setStatusLevel(level);

      gameoverClip = getAudioClip(getDocumentBase(), "audio/gameover.au");
      level = (int)(((double)(++countSoundsLoaded) / (double)6) * (double)100);
      loadingBarWindow.setStatusLevel(level);

      clickClip = getAudioClip(getDocumentBase(), "audio/click.au");
      level = (int)(((double)(++countSoundsLoaded) / (double)6) * (double)100);
      loadingBarWindow.setStatusLevel(level);

      correctClip = getAudioClip(getDocumentBase(), "audio/correct.au");
      level = (int)(((double)(++countSoundsLoaded) / (double)6) * (double)100);
      loadingBarWindow.setStatusLevel(level);

      incorrectClip = getAudioClip(getDocumentBase(), "audio/incorrect.au");
      level = (int)(((double)(++countSoundsLoaded) / (double)6) * (double)100);
      loadingBarWindow.setStatusLevel(level);

*/
      loadingBarWindow.setStatusLevel(100);
  }
}
