/*
 * Project: MW Dilemma Game
 *    File: PpiKki.java
 *    Date: 2 10, 2001
 * Authhor: Yongwoo's Park.
 */

import java.net.*;
import java.io.*;
import java.util.Enumeration;
import java.util.StringTokenizer;

public class PpiKki extends Thread {
   final static int MW_GAME_PORT=4001;
   Lobby lobby=null;

   ServerSocket ppikkiSocket=null;

   public static void main(String args[]) {
      System.out.println("MW Game Server Running...");

      PpiKki ppikki = new PpiKki();

      ppikki.start();
   }

   public PpiKki() {
      try {
         ppikkiSocket = new ServerSocket(MW_GAME_PORT);
      } catch(IOException e) {
         System.out.println("IOException: "+e);
         System.exit(1);
      }
      lobby = new Lobby();
      lobby.start();
   }

   public void run() {
      Socket socket=null;
      ServerPlayer player=null;

      System.out.println("PpiKki thread is started...");
      while(true) {
         try {
            socket = ppikkiSocket.accept();
            if(socket == null) {
               System.out.println("Can't create a socket...");
               continue;
            } else {
               player = new ServerPlayer(socket, lobby, null);
               if(player == null) {
                  System.out.println("Can't create a player...");
                  continue;
               }
            }
            lobby.addPlayer(player);
         } catch(Exception e) {
            e.printStackTrace();
         }
      }
//      System.out.println("PpiKki thread is finished...");
   }
}
