import java.awt.*;
import java.awt.event.*;

class WarningDialog extends Dialog {
   Button okButton=null, msgButton=null;

   public WarningDialog(Frame owner, String title, String message) {
      super(owner, title, true);

      setLayout(new BorderLayout());

      msgButton = new Button(message);
      okButton = new Button("OK");

      Panel p = new Panel();
      p.add(okButton);

      add("Center", msgButton);
      add("South", p);

      okButton.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            dispose();
         }
      });

      addWindowListener(new WindowAdapter() {
         public void windowClosing(WindowEvent e) {
            dispose();
         }
      });

      okButton.addMouseListener(new MouseAdapter() {
         public void mouseEntered(MouseEvent e) {
            e.getComponent().setForeground(Color.red);
         }
         public void mouseExited(MouseEvent e) {
            e.getComponent().setForeground(Color.black);
         }
      });

      pack();
      if(getSize().width < 300) {
         setSize(320, 120);
      }
      autoAlign();

      okButton.requestFocus();
   }

   public void autoAlign() {
      int w = Toolkit.getDefaultToolkit().getScreenSize().width;
      int h = Toolkit.getDefaultToolkit().getScreenSize().height;
      int x = (((w - getSize().width) / 2) < 0) ? 0 : ((w - getSize().width) / 2);
      int y = (((h - getSize().height) / 2) < 0) ? 0 : ((h - getSize().height) / 2);

      setLocation(x, y);
   }

   public void setVisible(boolean b) {
      if(b) {
         show();
         toFront();
         requestFocus();
      } else {
         hide();
      }
   }
}

