package rndclub.game.piece;
import java.io.*;
import java.util.Date;

import java.awt.*;
import java.applet.*;
import java.awt.event.*;


public class Piece extends Applet implements Runnable {
   private static final int NUM=9; //   ϴ Դϴ.
   private int contents[][];       //   ȣ ϴ 迭Դϴ.
   private Image image[][];        // 9  ׸ Ű Դϴ.
   private Image bufferedImage;    //  ȭ  ϴ Դϴ.
   private Graphics bg;            //  ȭ Ű Դϴ.
   private int icur,ipre;          //   ġ ġ ϴ Դϴ.
   private String currentMsg=null;
   private long startTime=0, elapsedTime=0;
   Thread elapsedThread = null;
   int imageNum=0;

   Canvas imageCanvas;
   Panel commandPanel;
   Panel elapsedTimePanel;

   Button startButton;
   Button stopButton;
   Label imageLabel;
   Choice imageChoice;
   Label elapsedLabel;
   Label elapsedTimeLabel;

   private boolean gameFlag=false;
   private boolean itemStateChangedFlag = true;

   public void start() {
      if(gameFlag == true) {
         if(elapsedThread == null) {
            elapsedThread = new Thread(this);
         }
         elapsedThread.start();
      }
   }

   public void stop() {
      elapsedThread = null;
   }

   public void run() {
      long t;
      int hh, mm, ss, msec;

      while(true) {
         if(gameFlag == true) {
            elapsedTime = new Date().getTime() - startTime;
            t = elapsedTime;
            hh = (int)(t / (1000 * 60 * 60)); t = (int)(t % (1000 * 60 * 60));
            mm = (int)(t / (1000 * 60));      t = (int)(t % (1000 * 60));
            ss = (int)(t / 1000);
/*
            elapsedTime = (int)(t % 1000);
            msec = (int)(t);
*/

            if(elapsedTimeLabel != null) {
               elapsedTimeLabel.setText(hh+":"+mm+":"+ss);
/*
               elapsedLabel.setText(hh+":"+mm+":"+ss+"."+msec);
*/
            } else {
            }
         }
         try {
            Thread.sleep(1000);
         } catch (InterruptedException e) { }
      }
   }

   public void startGame() {
      if(gameFlag == false) {
         Randomize();
         startTime = new Date().getTime();

         gameFlag=true;
         startButton.setEnabled(false);
         stopButton.setEnabled(true);
         imageChoice.setEnabled(false);
         imageCanvas.setEnabled(true);

         start();
      }
      repaint();
   }

   public void stopGame() {
      if(gameFlag == true) {
         gameFlag=false;

         startButton.setEnabled(true);
         stopButton.setEnabled(false);
         imageChoice.setEnabled(true);
         imageCanvas.setEnabled(false);

         stop();
      }
      repaint();
   }

   public void init() {                     // ø ϸ ۵Ǵ ޼ҵԴϴ.
      imageCanvas = new Canvas();
      commandPanel = new Panel();
      elapsedTimePanel = new Panel();

      startButton = new Button("Start");
      stopButton = new Button("Stop");
      imageLabel = new Label("  Select image:");
      imageChoice = new Choice();
      elapsedLabel = new Label("Elapsed Time: ");
      elapsedTimeLabel = new Label("00:00:00");

      setLayout(new BorderLayout());

      elapsedTimePanel.add(elapsedLabel);
      elapsedTimePanel.add(elapsedTimeLabel);

      commandPanel.add(startButton);
      commandPanel.add(stopButton);
      commandPanel.add(imageLabel);
      commandPanel.add(imageChoice);

      add(elapsedTimePanel, BorderLayout.NORTH);
      add(imageCanvas, BorderLayout.CENTER);
      add(commandPanel, BorderLayout.SOUTH);

      int imageDirs = Integer.parseInt(getParameter("imageDirs"));
      for(int i=0;i<imageDirs;i++) {
         imageChoice.addItem(getParameter("imageDir["+i+"]"));
      }

      image = new Image[imageDirs][NUM];     // 9  ׸  ޸𸮸 մϴ.
      contents = new int[3][3];              // ׸ ȣ  ޸𸮸 մϴ.
                                             //  丮 ׸ ҷ image迭 մϴ.
      bufferedImage = createImage(300,300);  //  ̹   մϴ.
      bg = bufferedImage.getGraphics();      //  ׷ ü մϴ.

      loadImages();

      MouseAdapter ml = new MouseAdapter() {
         public void mouseEntered(MouseEvent e) {
            e.getComponent().setForeground(Color.red);
         }
         public void mouseExited(MouseEvent e) {
            e.getComponent().setForeground(Color.black);
         }
      };
      startButton.addMouseListener(ml);
      stopButton.addMouseListener(ml);

      ActionListener al = new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            if(e.getActionCommand() == "Start") {
               startGame();
            } else if(e.getActionCommand() == "Stop") {
               stopGame();
            }
         }
      };
      startButton.addActionListener(al);
      stopButton.addActionListener(al);

      imageChoice.addItemListener(new ItemListener() {
         public void itemStateChanged(ItemEvent e) {
            itemStateChangedFlag = true;
            repaint();
         }
      });

      imageCanvas.addMouseListener(new MouseAdapter() {
         public void mouseClicked(MouseEvent e) {
            int x = e.getX(), y = e.getY();
            int ix = icur % 3;
            int iy = icur / 3;
            int x1 = ix*100, x2=(ix+1)*100-1;
            int y1 = iy*100, y2=(iy+1)*100-1;

            boolean keyFlag=false;

            if((x >= x1)&&(x <= x2)) {
               if((y < y1)&&(y > (y1-100))) {             // Up BlackBox
                  if(icur >= 3) {       //  2,3° ٿ   Ʒ ̵ϰ մϴ.
                     ipre=icur;         // ٲ  ġ մϴ.
                     icur -= 3;         //  ġ 3ŭ ҽŵϴ.

                     keyFlag = true;
                  }
               } else if((y > y2)&&(y < (y2+100))) {      // Down BlackBox
                  if(icur <= 5) {       //  1,2° ٿ    ̵ϰ մϴ.
                     ipre=icur;         // ٲ  ġ մϴ.
                     icur += 3;         //  ġ 3ŭ ŵϴ.

                     keyFlag = true;
                  }
               }
            }
            if((y >= y1)&&(y <= y2)) {
               if((x < x1)&&(x > (x1-100))) {                         // Left BlackBox
                  if(icur >= 1&&((icur)%3 != 0)) {
                     ipre=icur;                       // ٲ  ġ մϴ.
                     icur-=1;
   
                     keyFlag = true;
                  }
               } else if((x > x2)&&(x < (x2+100))) {                  // Right BlackBox
                  if(icur<=7&&(icur%3!=2)) {
                     ipre=icur;                // ٲ  ġ մϴ.
                     icur+=1;
   
                     keyFlag = true;
                  }
               }
            }
            if(keyFlag == true) {
               replace();
               repaint();

               Congraturation();
            } else {
               Toolkit.getDefaultToolkit().beep();
            }
         }
      });
      startButton.setEnabled(true);
      stopButton.setEnabled(false);
      imageChoice.setEnabled(true);
      imageCanvas.setEnabled(false);

      repaint();
   }

   void loadImages() {
      currentMsg = "Please waiting for loading images....";
      repaint();

      int imageDirs = Integer.parseInt(getParameter("imageDirs"));
      String imageDir = getParameter("imageDir");
      MediaTracker tracker = new MediaTracker(this);
      for(int i=0;i<imageDirs;i++) {
         image[i][0] = getImage(getDocumentBase(), imageDir+"/0.jpg");
         for(int j=1;j<NUM;j++) {
            image[i][j] = getImage(getDocumentBase(), imageDir+"/" + imageChoice.getItem(i)+"/" + j + ".jpg");
            tracker.addImage(image[i][j], 0);
         }
      }

      try {
         tracker.waitForAll();
      } catch (InterruptedException e) { }

      currentMsg = null;
      imageNum = 0;
   }

   public void repaint() {
      update(getGraphics());
      super.repaint();
   }

   /*  ׸ ޼ҵ */
   public void paint(Graphics g) {
      g = imageCanvas.getGraphics();
      if(itemStateChangedFlag == true) {
         int i;
         for(i=0;i<NUM-1;i++) {
            contents[i%3][i/3] = i+1;
         }
         contents[i%3][i/3] = 0;
         ipre = i;
         icur = i;
         itemStateChangedFlag = false;
         imageNum = imageChoice.getSelectedIndex();
      }
      if(currentMsg != null) {
         g.drawString(currentMsg, 32, 16);
      } else {
         //  ִ 迭 ׸ ȭ鿡 մϴ.
         for(int i=0;i<NUM;i++) {
            bg.drawImage(image[imageNum][contents[i%3][i/3]], (i%3)*100, (i/3)*100, 100, 100, this);
         }
         // ȭ鿡 ׸ մϴ.
         g.drawImage(bufferedImage, 0, 0, this);
      }
      currentMsg = null;

      this.requestFocus();                 // ׸ ٽ ׷  ȭ鿡  ̵ŵϴ..
   }

   /* repaint()޼ҵ尡 ȣϴ ޼ҵ */
   public void update(Graphics g) {
      paint(g);        // paint()޼ҵ带 ȣմϴ.
   }

   /* Ű ̺Ʈ ó ޼ҵ */

      public boolean keyDown(Event evt, int key) {
      // ȭǥŰ   ˻ϰ  ġ ٲߴϴ.
      //ǿ Ǹ  ߻ŵϴ.

      if(gameFlag == false) {
         return true;
      }

      boolean keyFlag=false;
      switch(key) {
         case Event.UP:
            if(icur <= 5) {       //  1,2° ٿ    ̵ϰ մϴ.
               ipre=icur;         // ٲ  ġ մϴ.
               icur += 3;         //  ġ 3ŭ ŵϴ.

               keyFlag = true;
            }
         break;
         case Event.DOWN:         // Ʒ ȭǥŰ   ˻ϰ  ġ ٲߴϴ.
            if(icur >= 3) {       //  2,3° ٿ   Ʒ ̵ϰ մϴ.
               ipre=icur;         // ٲ  ġ մϴ.
               icur -= 3;         //  ġ 3ŭ ҽŵϴ.

               keyFlag = true;
            }
         break;
         case Event.LEFT:                //  ȭǥŰ   ˻ϰ  ġ ٲߴϴ.
            if(icur<=7&&(icur%3!=2)) {
               ipre=icur;                // ٲ  ġ մϴ.
               icur+=1;
   
               keyFlag = true;
            }
         break;
         case Event.RIGHT:                      // ȭǥŰ   ˻ϰ  ġ ٲߴϴ.
            if(icur >= 1&&((icur)%3 != 0)) {
               ipre=icur;                       // ٲ  ġ մϴ.
               icur-=1;
   
               keyFlag = true;
            }
         break;
      }
      if(keyFlag == true) {
         replace();
         repaint();

         Congraturation();
      } else {
         Toolkit.getDefaultToolkit().beep();
      }

      return true;
   }

   // ġ  ġ  ٲߴϴ.
   private void replace() {
      int temp;
   
      temp = contents[icur%3][icur/3];
      contents[icur%3][icur/3] = contents[ipre%3][ipre/3];
      contents[ipre%3][ipre/3] = temp;
   }

   /*  ڼ ޼ҵ Դϴ. */
   private void Randomize() {
      int value=0;
      boolean check[]=new boolean[NUM];     // ڰ ߺǴ üũϴ Դϴ. 

      for(int i=0;i<NUM;) {
         value=(int)(Math.random() * 10);
         value=value % 9;                   // ߻  9   մϴ.
   
                                            // System.out.println(" = "+value);
         if(check[value]==false) {
            check[value]=true;
            contents[i%3][i/3]=value;
   
            if(value==0) icur=ipre=i;       //   ġ մϴ.
   
            i++;
         }
      }
   }

   private void Congraturation() {
      int count=0;
   
      Graphics g = imageCanvas.getGraphics();
      for(int i=0;i<NUM-1;i++) {
         if(contents[i%3][i/3] == (i+1)) count++;
      }
      if(count == 8) {
         g.drawString("Ŭ!!!", 210, 230);
         g.drawString("5Ŀ", 210, 250);
         g.drawString("ٽý", 210, 270);
         g.drawString("մϴ.", 210, 290);

         play(getCodeBase(),"gong.au");

         repaint();
         stopGame();
      } else {
         if(elapsedTime > 3 * 60 * 1000) {
System.out.println("parent: " + this.getParent());
            Dialog d = new Dialog((Frame)this.getParent(), "׳ ҷ?");
            d.show();
         }
      }
   }   

   public void destroy() {
      if(bg != null) {
         bg.dispose();                       //  ȭ ڿ ݳմϴ.
      }
   }
}
