/*
 * Copyright (c) 2000 Yongwoo's Park. All Rights Reserved.
 */

package rndclub.game.godori;

import java.io.*;
import java.net.*;

import java.util.StringTokenizer;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;

public class ClientLobby extends Applet implements Runnable {
   public Frame baseFrame=null; 

   Thread clientLobbyThread=null;
   String GODORI_SERVER=null, roomId=null, selectRoom=null;
   final static int GODORI_PORT=4001;

   public Socket socket=null;
   public BufferedReader is=null;
   public PrintWriter os=null;

   private AppletContext appletContext = null;
   String username = null;
   private boolean connFlag = false;

   AudioClip strikeAudioClip=null;
   AudioClip ssamAudioClip=null;
   AudioClip shakeAudioClip=null;
   AudioClip kissAudioClip=null;
   AudioClip dripAudioClip=null;
   AudioClip goAudioClip=null;
   AudioClip stopAudioClip=null;

   ImageCanvas backgroundCanvas = null;
   Button makeButton = null, joinButton = null, exitButton = null;
   Button searchButton = null, lawButton = null, toptenButton = null;
   Button roomInfoButton = null, userInfoButton = null;
   TextArea chatArea = null;
   TextField chat = null;
   List roomList = null, userList = null;
   Panel downPan = null, chatPan = null, boardPan = null, roomPan = null;

   String playerId=null;  //getParameter elements from now!
   String id = null;
   int playerPoint=0;
   String sex = null;
   int age = 0;
   int total = 0;
   int win = 0;
   int lose = 0;
   String position = null;

   CardLayout godoriCardLayout=null;
   Panel cardPanel=null;
   Panel lobbyPanel=null;
   GClient boardPanel=null;

   boolean currentRoomIsLobby=true;
   boolean loaded = false;
   Graphics offGraphics = null;

   PopupMenu popupMenu=null;

   public void initBaseFrame() {
      int i=1;
      Component c = ClientLobby.this;
      while(c!=null) {
         System.out.println("c-"+i+" : "+c.toString());
         if(c.toString().indexOf("frame")>=0) {
            baseFrame = (Frame)c;
         }
         c = c.getParent();
      }
      if(baseFrame==null) {
         baseFrame = new Frame();
      }
   }

   public void init() {
      initBaseFrame();

      StatusDialog s = new StatusDialog(baseFrame,
                                        "ʱȭ  ̹ ε  â",
                                        "Ѻ   ʱȭ  ̹ ε մϴ... (ִ: 15~20)");

      s.show();
      s.setMessage("ʱȭ  ̹ ε մϴ... (ִ: 15~20)", 1000);

      godoriCardLayout = new CardLayout();

      cardPanel = new Panel(godoriCardLayout);

      s.setMessage("̹ 带 εԴϴ...", 500);

      lobbyPanel = initLobbyPanel();

      boardPanel = new GClient(ClientLobby.this);

      s.setMessage("   մϴ...", 500);

      connect();

      s.setMessage(" г ̾ƿ մϴ...", 500);

      cardPanel.add(lobbyPanel, "Lobbypanel");
      cardPanel.add(boardPanel, "BoardPanel");

      setLayout(new BorderLayout());
      add("Center", cardPanel);

      s.setMessage("  ϷǾϴ...", 1000);
      s.dispose();
   }

   public Panel initLobbyPanel() {
      try {
         strikeAudioClip = getAudioClip(getDocumentBase(), "audio/Smass018.au");
         ssamAudioClip = getAudioClip(getDocumentBase(), "audio/Ahh.au");
         shakeAudioClip = getAudioClip(getDocumentBase(), "audio/Carhorn2.au");
         kissAudioClip = getAudioClip(getDocumentBase(), "audio/Kiss.au");
         dripAudioClip = getAudioClip(getDocumentBase(), "audio/Drip.au");
         goAudioClip = getAudioClip(getDocumentBase(), "audio/Cuckoo.au");
         stopAudioClip = getAudioClip(getDocumentBase(), "audio/Cuckoo.au");

      } catch(Exception e) {
      }
      Panel lobbyPanel = new Panel(null);
      setSize(800, 584);

      GODORI_SERVER = getCodeBase().getHost();

      Image backImage = getImage(getDocumentBase(), "images/background-1.jpg");
      MediaTracker backTracker = new MediaTracker(this);

      backTracker.addImage(backImage, 0);
      try {
         backTracker.waitForAll();
      } catch(InterruptedException e) {
      }

      backgroundCanvas = new ImageCanvas(backImage, this, 800, 584);
      backgroundCanvas.setBounds(0, 0, 800, 584);

      roomList = new List(13, false);
      roomList.setForeground(Color.blue);
      userList = new List(12, false);
      userList.setForeground(Color.blue);
      chatArea = new TextArea(7, 15);
      chat = new TextField(15);

      makeButton = new Button("游");
      joinButton = new Button("");
      exitButton = new Button("");
      searchButton = new Button("ID˻");
      lawButton = new Button("ӱ");
      toptenButton = new Button("ٷŷ");
      roomInfoButton = new Button(""+0);
      userInfoButton = new Button(""+0);

      roomList.setBounds(12, 145, 357, 210);
      roomList.setBackground(new Color(207,218,228));
      userList.setBounds(384, 145, 183, 210);
      userList.setBackground(new Color(234,234,206));

      chatArea.setBounds(94, 389, 468, 101);
      chatArea.setBackground(new Color(207,218,228));
      chat.setBounds(16, 502, 546, 23);
      chat.setBackground(new Color(234,234,206));

      makeButton.setBounds(202, 542, 59, 23);
      makeButton.setBackground(new Color(184,184,218));
      joinButton.setBounds(266, 542, 59, 23);
      joinButton.setBackground(new Color(184,184,218));
      exitButton.setBounds(330, 542, 59, 23);
      exitButton.setBackground(new Color(184,184,218));
      searchButton.setBounds(618,325,50, 21);
      searchButton.setBackground(new Color(184,184,218));
      lawButton.setBounds(672, 325, 50, 21);
      lawButton.setBackground(new Color(184,184,218));
      toptenButton.setBounds(726, 325, 50, 21);
      toptenButton.setBackground(new Color(184,184,218));
      roomInfoButton.setBounds(691,454,25,14);
      roomInfoButton.setBackground(new Color(184,184,218));
      roomInfoButton.setFont(new Font("Arial",Font.BOLD,8));
      userInfoButton.setBounds(691,470,25,14);
      userInfoButton.setBackground(new Color(184,184,218));
      userInfoButton.setFont(new Font("Arial",Font.BOLD,8));

      lobbyPanel.add(roomList);
      lobbyPanel.add(userList);

      lobbyPanel.add(chatArea);
      lobbyPanel.add(chat);

      lobbyPanel.add(makeButton);
      lobbyPanel.add(joinButton);
      lobbyPanel.add(exitButton);
      lobbyPanel.add(searchButton);
      lobbyPanel.add(lawButton);
      lobbyPanel.add(toptenButton);
      lobbyPanel.add(userInfoButton);
      lobbyPanel.add(roomInfoButton);

      lobbyPanel.add(backgroundCanvas);

      if(roomList.getItemCount() != 0) {
      }

      roomList.addItemListener(new ItemListener() {
         public void itemStateChanged(ItemEvent e) {
            if(e.getStateChange() == ItemEvent.SELECTED) {
               selectRoom = roomList.getSelectedItem();
               if(selectRoom != null && !"".equals(selectRoom)) {
                  selectRoom = selectRoom.substring(0, selectRoom.lastIndexOf('(')-1).trim();
                  sendToServer("350|"+playerId+"|"+selectRoom);
                  if("".equals(selectRoom)) {
                     joinButton.setEnabled(false);
                  }
               }
            }
         }
      });

      ActionListener wa = new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            if(e.getSource() == chat) {
               String str = chat.getText();
               if(str != null && !"".equals(str)) {
                  sendToServer("300|"+playerId+"|*|"+str);
               }
               chat.setText("");
            } else if(e.getSource() == userList) {
               if(("".equals(selectRoom))&&
                  (!playerId.equals(userList.getSelectedItem()))) {
                  TextDialog s = new TextDialog(baseFrame,
                                                 "ӼӸ ϱ...",
                                                 "["+userList.getSelectedItem()+"] Բ  ޽ Էϼ...");

                  userList.setEnabled(false);
                  s.show();
                  userList.setEnabled(true);

                  if(!"".equals(s.field.getText().trim())) {
                     String message = "302|";
                     message += "|" + playerId;
                     message += "|" + userList.getSelectedItem();
                     message += "|" + s.field.getText().trim();

                     sendToServer(message);
                  }
               }
            } else if(e.getSource() == makeButton) {
               makeButton.setEnabled(false);
               joinButton.setEnabled(false);
               exitButton.setEnabled(false);
               TextDialog s = new TextDialog(baseFrame,
                                             " ...",
                                             " ̸ Էϼ...");

               s.show();

               if(!"".equals(s.field.getText().trim())) {
                  roomId = s.field.getText().trim();
                  boolean existFlag = false;
                  String items[] = roomList.getItems();
                  for(int i=0;i<items.length;i++) {
                     if(items[i].trim().equals(roomId)) {
                        existFlag = true;
                        break;
                     }
                  }
                  if(existFlag == false) {
                     selectRoom = roomId;
                     sendToServer("360|"+playerId+"|"+roomId);
                     sendToServer("362|"+playerId+"|"+selectRoom);

                     boardPanel.initComponent();

                     godoriCardLayout.show(cardPanel, "BoardPanel");
                     currentRoomIsLobby = false;

                     sendToServer("501|fromID|*|enter");
                  } else {
                     WarningDialog w = new WarningDialog(baseFrame,
                                                         "Godori Warning",
                                                         "̸ ߺǾϴ.");
                     w.show();

                     makeButton.setEnabled(true);
                     selectRoom = roomList.getSelectedItem();
                     selectRoom = selectRoom.substring(0, selectRoom.lastIndexOf('(')-1).trim();
                     if(selectRoom != null && !"".equals(selectRoom)) {
                        if(!"".equals(selectRoom)) {
                           joinButton.setEnabled(true);
                        } else {
                           joinButton.setEnabled(false);
                        }
                     } else {
                        joinButton.setEnabled(false);
                     }
                     exitButton.setEnabled(true);
                  }
               } else {
                  makeButton.setEnabled(true);
                  selectRoom = roomList.getSelectedItem();
                  selectRoom = selectRoom.substring(0, selectRoom.lastIndexOf('(')-1).trim();
                  if(selectRoom != null && !"".equals(selectRoom)) {
                     if(!"".equals(selectRoom)) {
                        joinButton.setEnabled(true);
                     } else {
                        joinButton.setEnabled(false);
                     }
                  } else {
                     joinButton.setEnabled(false);
                  }
                  exitButton.setEnabled(true);
               }
            } else if(e.getSource() == joinButton) {
               selectRoom = roomList.getSelectedItem();
               selectRoom = selectRoom.substring(0, selectRoom.lastIndexOf('(')-1).trim();
               if(selectRoom != null && !"".equals(selectRoom)) {
                  sendToServer("362|"+playerId+"|"+selectRoom);

                  boardPanel.joinButton.setEnabled(true);
                  boardPanel.exitButton.setEnabled(true);

                  godoriCardLayout.show(cardPanel, "BoardPanel");
                  currentRoomIsLobby = false;
                  sendToServer("501|fromID|*|enter");
               }
            } else if(e.getSource() == searchButton) {
               TextDialog s = new TextDialog(baseFrame,
                                             " ˻...", "˻ ̵ Էϼ...");
               s.show();
               if(!"".equals(s.field.getText().trim())) {
                  String message = "374|"+playerId+"|"+s.field.getText().trim();
                  sendToServer(message);
               }
            } else if(e.getSource() == lawButton) {
                try {
                  String setRestartURLString = "http://"
                                             + getDocumentBase().getHost()
                                             + ":"+getDocumentBase().getPort()
                                             + "/rndclub/gamepark/godori/Help.htm";
                  URL setRestartURL = new URL(setRestartURLString);
                  getAppletContext().showDocument(setRestartURL,"_blank");
               } catch(MalformedURLException ee) {
                  System.out.println(ee);
                  ee.printStackTrace();
               }
            } else if(e.getSource() == toptenButton) {
                try {
                  String setRestartURLString = "http://"
                                             + getDocumentBase().getHost()
                                             + ":"+getDocumentBase().getPort()
                                             + "/rndclub/gamepark/godori/TopTen.jsp";
                  URL setRestartURL = new URL(setRestartURLString);
                  getAppletContext().showDocument(setRestartURL,"_blank");
               } catch(MalformedURLException ee) {
               }
            } else if(e.getSource() == exitButton) {
               sendToServer("320|"+playerId);
               try {
                  if (is != null) {
                     is.close();
                     is = null;
                  }
               } catch (Exception e1) {
               }
               try {
                  if (os != null) {
                     os.close();
                     os = null;
                  }
               } catch (Exception e1) {
               }
               try {
                  if (socket != null) {
                     socket.close();
                     socket = null;
                  }
               } catch (Exception e1) {
               }

/*
 *  ư   URL  ־ Ѵ..
 */
               try {
                  String setRestartURLString = "http://"
                                             + getDocumentBase().getHost()
                                             + ":"+getDocumentBase().getPort()
                                             + "/rndclub/gamepark/godori/Finish.jsp?id="+playerId;
                  URL setRestartURL = new URL(setRestartURLString);
                  getAppletContext().showDocument(setRestartURL);
               } catch(MalformedURLException ee) {
               }
            }
         }
      };

      chat.addActionListener(wa);
      makeButton.addActionListener(wa);
      joinButton.addActionListener(wa);
      exitButton.addActionListener(wa);
      searchButton.addActionListener(wa);
      lawButton.addActionListener(wa);
      toptenButton.addActionListener(wa);
      userList.addActionListener(wa);

      FocusListener fl = new FocusAdapter() {
         public void focusGained(FocusEvent e) {
            chat.requestFocus();
         }
      };

      popupMenu = new PopupMenu("ӼӸϱ..");
      MenuItem unicastChatMenuItem = new MenuItem("ӼӸϱ..");
      MenuItem profileMenuItem = new MenuItem("");
      popupMenu.add(unicastChatMenuItem);
      popupMenu.add(profileMenuItem);
      unicastChatMenuItem.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            selectRoom = roomList.getSelectedItem();
            selectRoom = selectRoom.substring(0, selectRoom.lastIndexOf('(')-1).trim();
            if(("".equals(selectRoom))&&
               (!playerId.equals(userList.getSelectedItem()))) {
               TextDialog s = new TextDialog(baseFrame,
                                              "ӼӸ ϱ...",
                                              "[" + userList.getSelectedItem()
                                              + "] Բ  ޽ Էϼ...");

               userList.setEnabled(false);
               s.show();
               userList.setEnabled(true);

               if(!"".equals(s.field.getText().trim())) {
                  String message = "302|";
                  message += "|" + playerId;
                  message += "|" + userList.getSelectedItem();
                  message += "|" + s.field.getText().trim();

                  sendToServer(message);
               }
            }
         }
      });

      profileMenuItem.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            selectRoom = roomList.getSelectedItem();
            selectRoom = selectRoom.substring(0, selectRoom.lastIndexOf('(')-1).trim();
            if((selectRoom != null)&&(!"".equals(selectRoom))) {
               String message = "372|"+playerId+"|"+userList.getSelectedItem();
               sendToServer(message);
           }
         }
      });

      userList.add(popupMenu);
      userList.addMouseListener(new MouseAdapter() {
         public void mousePressed(MouseEvent e) {
            if((userList.getSelectedItem() != null)&&
               (e.getModifiers() == InputEvent.META_MASK)) {
               popupMenu.show(e.getComponent(), e.getX(), e.getY());
            }
         }
      });

      roomList.addFocusListener(fl);
      userList.addFocusListener(fl);
      chatArea.addFocusListener(fl);
      chat.addFocusListener(fl);

      chat.requestFocus();

      joinButton.setEnabled(false);

      return(lobbyPanel);
   }

   private void connect() {
      connFlag = false;
      try {
         socket = new Socket(GODORI_SERVER, GODORI_PORT);
      } catch(UnknownHostException e) {
         chatArea.append("ܹ߻: "+e+"\n");
         return;
      } catch(IOException e) {
         chatArea.append("ܹ߻: "+e+"\n");
         return;
      }

      //Try to open streams to read and write from the socket.
      try {
        is = new BufferedReader(new InputStreamReader(socket.getInputStream()));
        os = new PrintWriter(socket.getOutputStream(), true);
      } catch(IOException e) {
         chatArea.append("ܹ߻: "+e+"\n");
         stop();
         return;
      }

      if((os != null) & (is != null)) {
         // Let the main applet thread know we've successfully connected.
         // portField.setEditable(false);
         // connectButton.disable();
         // trysted = true;
         // notify();
      } else {
         chatArea.append("ܹ߻: Ͽ а   ϴ.\n");
      }

//      playerId = new Date().toString();
//      ASPκ <PARAM> ũ ؼ ̵ Ʈ 

      sex = getParameter("sex");
      age = Integer.parseInt(getParameter("age"));
      win = Integer.parseInt(getParameter("win"));
      lose = Integer.parseInt(getParameter("lose"));
      total = Integer.parseInt(getParameter("total"));
      position = getParameter("position");
      id = getParameter("id");
      playerId=id;

      if(id == null) {                // ̵ ĶͰ 
         getAppletContext().showDocument(getDocumentBase(), "Error.jsp?error=NO_ID");
      }
      if(getParameter("point") == null) {   // Ʈ ĶͰ 
         getAppletContext().showDocument(getDocumentBase(), "Error.jsp?error=NO_POINT");
      }
      try {
         playerPoint = Integer.parseInt(getParameter("point"));
      } catch(NumberFormatException e) {   // Ʈ ĶͰ ڰ ƴ
         getAppletContext().showDocument(getDocumentBase(), "Error.jsp?error=InvalidPoint");
      }
/*      if(playerPoint < 10) {   // ʹ  Ʈ  ,  
         getAppletContext().showDocument(getDocumentBase(), "Error.jsp?error=InsufficientPoint");
      }
*/

      String receive=null;
      StringTokenizer st = null;
      String command = null;
      try {
         // ʱ  ۾ - ܸ   ̵ Ȯ
         receive = receiveMessage();  // "Username" is read
         sendToServer(playerId);
         sendToServer("310|"+playerId);
         sendToServer("352|"+playerId);

         // ÷̾  
         String profileMessage = "370|" + playerId + "|"
                               + playerPoint + ","
                               + sex + ","
                               + age + ","
                               + win + ","
                               + lose + ","
                               + total + ","
                               + position;
         sendToServer(profileMessage);
      } catch(Exception e) { //Unknown error. Throw tantrum.
         chatArea.append("ܹ߻: "+e+"\n");
      }
      connFlag = true;
      try {
         // 10ms ŸӾƿ 
         socket.setSoTimeout(10);
      } catch(SocketException e) {
         chatArea.append("ܹ߻: "+e+"\n");
      }
   }

   public synchronized void destroy() {
      //robbyThread = null;
      if(clientLobbyThread != null) {
         //clientLobbyThread.stop();
         clientLobbyThread = null;
         // notify();
      }
      try { //Close input stream.
         if(is != null) {
            is.close();
            is = null;
         }
      } catch(Exception e) {
         System.out.println(e);
         e.printStackTrace();
      } //Ignore exceptions.

      try { //Close output stream.
         if(os != null) {
            os.close();
            os = null;
         }
      } catch(Exception e) {
         e.printStackTrace();
      } //Ignore exceptions.

      try { //Close socket.
         if(socket != null) {
            socket.close();
            socket = null;
         }
      } catch(Exception e) {
         e.printStackTrace();
      } //Ignore exceptions.
   }

   public synchronized void start() {
      if(clientLobbyThread == null) {
         try {
            if(socket != null) {
               if(is == null) {
                  is = new BufferedReader(
                             new InputStreamReader(socket.getInputStream()));
               }
               if(os == null) {
                  os = new PrintWriter(socket.getOutputStream(), true);
               }
            }
            clientLobbyThread = new Thread(this);
            clientLobbyThread.start();
         } catch(IOException e) {
         }
      }
   }

   public synchronized void stop() {
      clientLobbyThread = null;
   }

   public void sendToServer(String message) {
      if(message != null) {
         os.println(message);
         os.flush();

         if(os.checkError()) {
        }
      }
   }

   public String receiveMessage() throws SocketException {
      String message = null;
      try {
         message = is.readLine();
      } catch(SocketException e) {
         throw(e);
      } catch(Exception e) {
         return "";
      }
      return message;
   }

   public void run() {
      String receive=null;
      while(Thread.currentThread() == clientLobbyThread) {
         try {
            Thread.sleep(100);
         } catch(InterruptedException e) {
         }
         if(connFlag == false) {
            continue;
         }
         try {
            receive = receiveMessage();
            if(receive == null || "".equals(receive)) {
               continue;
            }

//            if(currentRoomIsLobby == true) {
               //  κ , κ񿡼 ޽ óƾ
               processMessage(receive);
//            } else {
               //   뿡 ,  뿡 ޽ óƾ
               boardPanel.processMessage(receive);
//            }
         } catch(SocketException e) { //Stream doesn't exist.
//            chatArea.append("   ϴ.\n");
//            chatArea.append(": ["+e+"\n");

            stop();

            return;
         } catch(Exception e) { //Unknown error. Throw tantrum.
         }

      }
   }

   public void processMessage(String receive) {
      StringTokenizer st = new StringTokenizer(receive, "|");
      String command = st.nextToken();
      if("400".equals(command)) {         // εĳ ä
         String fromId = st.nextToken();
         String toId = st.nextToken();
         String chat = st.nextToken();

         chatArea.append(chat+"\n");
      } else if("402".equals(command)) {  // ĳƮ ä (ӼӸ)
         String fromId = st.nextToken();
         String toId = st.nextToken();
         String chat = st.nextToken();

         chatArea.append("\n["+fromId+"] κ  ӼӸ.."+"\n");
         chatArea.append(chat+"\n\n");
      } else if("404".equals(command)) {
      } else if("410".equals(command)) {
         String fromId=st.nextToken();
         String comment=st.nextToken();
         chatArea.append(comment+"\n");
      } else if("420".equals(command)) {
      } else if("450".equals(command)) {
         String fromId=st.nextToken();
         String roomId=st.nextToken();

         selectRoom = roomList.getSelectedItem();
         selectRoom = selectRoom.substring(0, selectRoom.lastIndexOf('(')-1).trim();
         if(selectRoom != null &&
            selectRoom.equals(roomId)) {
            if(userList == null) {
               userList = new List(12, false);
            } else if(userList.getItemCount() > 0) {
               userList.removeAll();
            }

            String userStr=st.nextToken();
            StringTokenizer sst = new StringTokenizer(userStr, ",");

            while(sst.hasMoreTokens()) {
               try {
                  String user = sst.nextToken();
                  if(user != null && !"".equals(user)) {
                     userList.add(user);
                  }
               } catch(Exception ee) {
               }
            }

          /*
            //  濡 ִ ̿ 3    ..
            if(userList.getItemCount() <= 3) {
               joinButton.setEnabled(false);
            } */

            if(!"".equals(roomId)) {
               joinButton.setEnabled(true);
            }
         }
      } else if("452".equals(command)) {
         String fromId=null, roomNum=null, userNum=null, roomIds=null;
         try {
            fromId = st.nextToken();
            roomNum = st.nextToken();
            userNum = st.nextToken();
            roomIds = st.nextToken();
         } catch(Exception e) {
         }
         roomInfoButton.setForeground(Color.blue);
         userInfoButton.setForeground(Color.blue);
         roomInfoButton.setLabel(""+roomNum);
         userInfoButton.setLabel(""+userNum);

         String currRoomId=null;
         if(roomList == null) {
            roomList = new List(13, false);
         } else if(roomList.getItemCount() > 0) {
            currRoomId = roomList.getSelectedItem();
            roomList.removeAll();
            if((userList != null) && (userList.getItemCount() > 0)) {
               userList.removeAll();
            }
         }
         try {
            StringTokenizer sst = new StringTokenizer(roomIds, ",");
            while(sst.hasMoreTokens()) {
               String roomId = sst.nextToken();
               if(roomId != null && !"".equals(roomId)) {
                  roomList.add(roomId);
               }
            }
            if(currRoomId == null) {
               userList.removeAll();
            } else {
               boolean exists=false;
               for(int i=0;i<roomList.getItemCount();i++) {
                  if(currRoomId.equals(roomList.getItem(i))) {
                     roomList.select(i);

                     String message = "350|"+playerId+"|"+currRoomId;
                     sendToServer(message);

                     exists = true;
                     break;
                  }
               }
               if(exists == false) {
                  userList.removeAll();
               }
            }
         } catch(Exception ee) {
         }
      } else if("460".equals(command)) {
         String fromId=st.nextToken();
         String comment=st.nextToken();
      } else if("462".equals(command)) {
      } else if("466".equals(command)) {
      } else if("470".equals(command)) {
      } else if("472".equals(command)) {
         String toPlayer = st.nextToken();
         String who = st.nextToken();
         String profile = st.nextToken();
//       String profileMessage = "472|"+to+"|"+who+"|**^____^**";
         if(!"**^____^**".equals(profile)) {
            StringTokenizer sst = new StringTokenizer(profile, ",");
            String point=null, sex=null, age=null;
            String win=null, lose=null, total=null, position=null;
            try {
               point = sst.nextToken();
               sex = sst.nextToken();
               age = sst.nextToken();
               win = sst.nextToken();
               lose = sst.nextToken();
               total = sst.nextToken();
               position = sst.nextToken();
            } catch(Exception ee) {
            }
            ProfileDialog p
               = new ProfileDialog(baseFrame,
                                   " ڳԴϴ.",
                                   who,
                                   who, point, sex, age,
                                   total, win, lose, position);

            userList.setEnabled(false);
            p.show();
            userList.setEnabled(true);
         } else {
            ProfileDialog p
               = new ProfileDialog(baseFrame,
                                   " ڳԴϴ.", "**^____^**",
                                   "", "", "", "", "", "", "", "");

            userList.setEnabled(false);
            p.show();
            userList.setEnabled(true);
         }
      } else if("474".equals(command)) {
         String toPlayer = st.nextToken();
         String who = st.nextToken();
         String playerInfo = st.nextToken();
//       String profileMessage = "474|"+to+"|"+who+"|**^____^**";
         if(!"**^____^**".equals(playerInfo)) {
            StringTokenizer sst = new StringTokenizer(playerInfo, ",");
            String roomId=null, status=null;
            try {
               roomId = sst.nextToken();
               status = sst.nextToken();
            } catch(Exception ee) {
            }
            SearchDialog search
               = new SearchDialog(baseFrame,
                                  " ˻", " ˻ ",
                                  who, roomId, status);
            search.show();
//         }
         } else {
            SearchDialog search
               = new SearchDialog(baseFrame,
                                  " ˻", "**^____^**",
                                  who, "", "");
            search.show();
         }
      } else if("486".equals(command)) {
         // Commmand: 486|fromId|who|roomId
         // Description: GClientκ ClientLobby   ʴϱ û

         String fromId = st.nextToken();
         String who = st.nextToken();
         String roomId = st.nextToken();

//System.out.println("ʴޱ: "+fromId+", "+who+", "+roomId);
         InvitedDialog ii = new InvitedDialog(baseFrame, fromId, roomId);
         ii.show();

         if(ii.status == 1) {  // ϱ
            if(roomId != null && !"".equals(roomId)) {
               sendToServer("388|"+playerId+"|"+fromId+"|"+roomId+"|JOIN");

               sendToServer("362|"+playerId+"|"+roomId);

               boardPanel.joinButton.setEnabled(true);
               boardPanel.exitButton.setEnabled(true);

               godoriCardLayout.show(cardPanel, "BoardPanel");
               currentRoomIsLobby = false;
               sendToServer("501|"+playerId+"|*|enter");
            } else {
               sendToServer("388|"+playerId+"|"+fromId+"|"+roomId+"|REFUSE");
            }
         } else if(ii.status == -1) {  // ϱ
            sendToServer("388|"+playerId+"|"+fromId+"|"+roomId+"|REFUSE");
         }
      }
   }
}
